﻿using SimpleJSON;
using System;
using System.Linq;
using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using System.Collections.Generic;
using UnityEngine.EventSystems;
using uFileBrowser;
using Battlehub.RTCommon;
using System.Linq.Expressions;
using UnityThreading;
using System.Text;
using System.Text.RegularExpressions;
using MVR.FileManagementSecure;
using System.Security.Cryptography;
using Leap.Unity;
using System.Diagnostics;
using UnityEngine.Events;

namespace VAM_Decal_Maker
{
    public class Decal_Maker : MVRScript
    {
        const string pluginName = "DecalMaker";
        const string pluginVersion = "Beta 5";
        //person script is attatched too
        Atom _parentAtom; //VAM parent
        Atom _shaderAtom; //Obj holding shader
        bool _SetupFinished = false;
        int _queuedBakes = 0;

        public Shader _customBulkDecalShader { get; private set; }
        public Shader _customSpecGlossShader { get; private set; }
        public Shader _customNormShader { get; private set; }
        public Shader _customPackedNormShader { get; private set; }
        public Shader _customUINormalMapShader { get; private set; }
        public Shader _customUISpecularMapShader { get; private set; }
        public Shader _customUIGenitalMakerShader { get; private set; }
        public JSONClass _savedData { get; set; }
        public Texture2D _clearTex { get; private set; }
        public DAZMergedSkinV2 _dazSkin { get; private set; }
        public Dictionary<string, int[]> _TextureIndex
        {
            get
            {
                if (_isMale)
                    return maleTextureIndex;

                return femaleTextureIndex;
            }
        }
        Dictionary<string, int[]> femaleTextureIndex = new Dictionary<string, int[]>()
        {
            {"torso", new int[]{15,18,19,20,21,27,29}},
            {"face", new int[]{2,5,11} },
            {"limbs", new int[]{0,12,14,16,17,22,23}},
            {"genitals", new int[]{28}}
        };
        Dictionary<string, int[]> maleTextureIndex = new Dictionary<string, int[]>()
        {
            {"torso", new int[]{15,16,19,20,21,22,30,32}},
            {"face", new int[]{2,5,11}},
            {"limbs", new int[]{0,12,14,17,18,23,24}},
            {"genitals", new int[]{28,29}}
        };


        DAZCharacter _dazCharacter;
        DAZCharacterSelector _dazCharacterSelector;  
        bool _isMale;
        string _uvSetName;

        //UI
        JSONStorableBool _toggleNippleCutout = new JSONStorableBool("Nipple Cutouts ON", true);
        JSONStorableBool _toggleGenitalCutout = new JSONStorableBool("Genital Cutouts ON", true);

        UIDynamicButton _resetButton;
        UIDynamicButton _saveButton;
        UIDynamicButton _clearAllButton;
        UIDynamicButton _prefabButton;
        UIDynamicButton _savePresetButton;
        UIDynamicButton _loadPresetButton;

        UIDynamicToggle _toggleNipple;
        UIDynamicToggle _toggleGenital;

        HeaderPanel _headerPanel;
        //GenitalMaker _genitalMakerPanel;

        bool _Debug = false;

        public override void Init()
        {
            try
            {
                if (containingAtom.mainController == null)
                {
                    SuperController.LogError("Please add this plugin to a PERSON atom.");
                    return;
                }
                _parentAtom = containingAtom;
                _parentAtom.mainController.interactableInPlayMode = true;

                TempManager.mVR = this;

                //setup all values before finishing UI
                StartCoroutine(CharacterChanged());


                _clearAllButton = CreateButton("Clear Everything");
                _prefabButton = CreateButton("USE Prefab", true);

                PrefabPanel prefabPanel = new PrefabPanel(this);

                 //_genitalMakerPanel = new GenitalMaker(this);

                _resetButton = CreateButton("Reset Texture");
                _saveButton = CreateButton("Apply Texture", true);

                _loadPresetButton = CreateButton("Load Preset");
                _savePresetButton = CreateButton("Save Preset", true);

                _toggleNipple = CreateToggle(_toggleNippleCutout);
                _toggleGenital = CreateToggle(_toggleGenitalCutout, true);

                RegisterBool(_toggleNippleCutout);
                RegisterBool(_toggleGenitalCutout);

                //assign listners
                _clearAllButton.button.onClick.AddListener(ResetAll);

                _prefabButton.button.onClick.AddListener(prefabPanel.OnClick);

                _saveButton.button.onClick.AddListener(() =>
                {
                    TempManager.DestoryAll();
                    //ResetOriginalGPUTextures(_dazCharacter);
                    _headerPanel.Bake();
                });

                string presetsPath = "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Presets";
                if (!FileManagerSecure.DirectoryExists(presetsPath))
                {
                    FileManagerSecure.CreateDirectory(presetsPath);
                }
                if (!FileManagerSecure.DirectoryExists(presetsPath + "/PreFabs"))
                {
                    FileManagerSecure.CreateDirectory(presetsPath + "/PreFabs");
                }

                _savePresetButton.button.onClick.AddListener(() =>
                {
                    SuperController.singleton.fileBrowserUI.defaultPath = presetsPath;
                    SuperController.singleton.fileBrowserUI.showFiles = true;
                    SuperController.singleton.fileBrowserUI.showDirs = true;
                    SuperController.singleton.fileBrowserUI.SetTextEntry(true);
                    SuperController.singleton.fileBrowserUI.hideExtension = true;
                    SuperController.singleton.fileBrowserUI.shortCuts = new List<ShortCut>();
                    SuperController.singleton.fileBrowserUI.Show(SavePresetCallback);
                });

                _loadPresetButton.button.onClick.AddListener(() =>
                {
                    string presets = "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Presets";

                    SuperController.singleton.fileBrowserUI.defaultPath = presets;
                    SuperController.singleton.fileBrowserUI.SetTitle("Select Load Decal Preset");
                    SuperController.singleton.fileBrowserUI.showFiles = true;
                    SuperController.singleton.fileBrowserUI.showDirs = true;
                    SuperController.singleton.fileBrowserUI.SetTextEntry(false);
                    SuperController.singleton.fileBrowserUI.hideExtension = true;
                    List<ShortCut> shortCuts = FileManagerSecure.GetShortCutsForDirectory("Custom/Scripts/Chokaphi/VAM_Decal_Maker/Presets", false, true, true, false);
                    SuperController.singleton.fileBrowserUI.shortCuts = shortCuts;
                    SuperController.singleton.fileBrowserUI.Show(PresetLoadCallBack);
                });

                byte[] tmppng = FileManagerSecure.ReadAllBytes(GetPackagePath(this) + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Cutout/Clear.png");
                _clearTex = new Texture2D(1, 1, TextureFormat.RGBA32, false);
                _clearTex.LoadImage(tmppng);

                JSONStorableAction resetAllAction = new JSONStorableAction("ClearAll", ResetAll);
                RegisterAction(resetAllAction);
                JSONStorableAction performLoadAction = new JSONStorableAction("PerformLoad", PerformLoad);
                //RegisterAction(performLoadAction);

            }
            catch (Exception e)
            {
                SuperController.LogError("Decal Maker: Error during Init" + e);
            }
        }

        void LogError(string err)
        {
            if (_Debug)
            {
                SuperController.LogError(err);
            }
        }

        public void DebugSave(Texture2D tempTex, string name)
        {
            //string path = "Custom/Scripts/Chokaphi/OUT/" + name;
            //byte[] bytes = tempTex.EncodeToPNG();

            //FileManagerSecure.WriteAllBytes(path, bytes);
        }

        #region FileAccess Helpers
        //MacGruber Discord 03/26/2020
        //Get directory path where the plugin is located. Based on Alazi's & VAMDeluxe's method.
        public static string GetPluginPath(MVRScript self)
        {
            string id = self.name.Substring(0, self.name.IndexOf('_'));
            string filename = self.manager.GetJSON()["plugins"][id].Value;
            return filename.Substring(0, filename.LastIndexOfAny(new char[] { '/', '\\' }));
        }

        // Get path prefix of the package that contains our plugin.
        public string GetPackagePath()
        {
            return GetPackagePath(this);
        }
        public static string GetPackagePath(MVRScript self)
        {
            string filename = GetPluginPath(self);
            int idx = filename.IndexOf(":/");
            if (idx >= 0)
                return filename.Substring(0, idx + 2);
            else
                return string.Empty;
        }

        //By: VAMDeluxe Discord
        public List<string> GetFilesAtPathRecursive(string path, string pattern)
        {
            List<string> combined = new List<string>();
            string[] files = FileManagerSecure.GetFiles(path, pattern);
            string[] directories = FileManagerSecure.GetDirectories(path);

            List<ShortCut> shortCuts = FileManagerSecure.GetShortCutsForDirectory(path);

            files.ToList().ForEach(file =>
            {
                combined.Add(file);
            });

            directories.ToList().ForEach(directory =>
            {
                combined.AddRange(GetFilesAtPathRecursive(directory, pattern));
            });

            return combined;
        }
        //from C# PATH
        char[] sep = new char[] { '/', '\\' };
        public string GetFileName(string path)
        {
            int num = path.LastIndexOfAny(sep);
            if (num >= 0)
            {
                return path.Substring(num + 1);
            }
            return path;
        }
        #endregion

        #region Create Shader Asset Element
        //"project-canyon12/05/2018 DISCORD"
        //"I'm going on how I understand Async/Await works in normal C#, but I think the principle is the same"
        //tweaked for my use case
        delegate void AtomCreatedEvent(Atom atom);
        IEnumerator CreateAssetAtom(string uniqueAtomName, string nameOfGameObjectToFind)
        {
            //yield return new WaitForSeconds(0.5f);

            Atom createdAtom = GetAtomById(uniqueAtomName);
            if (createdAtom == null)
            {
                yield return SuperController.singleton.AddAtomByType("CustomUnityAsset", uniqueAtomName, true);

                createdAtom = GetAtomById(uniqueAtomName);
            }

            JSONStorable storable = createdAtom.GetStorableByID("asset");
            //should have always had this toggled. Prevents asset from being stored
            storable.exclude = true;
            storable.SetUrlParamValue("assetUrl", GetPackagePath(this) + @"Custom\Assets\Chokaphi\chokpahi-decal.assetbundle");
            storable.SetStringChooserParamValue("assetName", "Assets/Chokpahi-Decal.unity");

            yield return new WaitWhile(() => GameObject.Find(nameOfGameObjectToFind) == null);

            LogError("Asset loaded");
            _shaderAtom = createdAtom;

            LogError("Asset Shader loaded " + createdAtom);
        }

        private Shader DefineShaders()
        {
            Shader[] renderers = Resources.FindObjectsOfTypeAll<Shader>();
            LogError("Shader setup start " + renderers.Length);
            
            foreach (Shader shader in renderers)
            {
                if (shader.name == "Custom/Unlit-Specular")
                {
                    LogError("ShaderFind " + Shader.Find(shader.name) + " Spec-Gloss Shader is " + shader.name);
                    _customSpecGlossShader = shader;
                }
                if (shader.name == "Custom/Unlit-NormalMap2")
                {
                    LogError("ShaderFind " + Shader.Find(shader.name) + " Normal Shader is " + shader.name);
                    _customNormShader = shader;
                }
                if (shader.name == "Custom/Unlit-PackedNormalMap")
                {
                    LogError("ShaderFind " + Shader.Find(shader.name) + " PackedNorm Shader is " + shader.name);
                    _customPackedNormShader = shader;
                }
                if (shader.name == "Custom/Unlit-Decal4")
                {
                    LogError("ShaderFind " + Shader.Find(shader.name) + " BulkShader Shader is " + shader.name);
                    _customBulkDecalShader = shader;
                }
                if (shader.name == "Custom/UI-NormalMapOverlay")
                {
                    LogError("ShaderFind " + Shader.Find(shader.name) + " ui Shader is " + shader.name);
                    _customUINormalMapShader = shader;
                }
                if (shader.name == "Custom/Unlit-GenitalMaker2")
                {
                    LogError("ShaderFind " + Shader.Find(shader.name) + " ui Shader is " + shader.name);
                    _customUIGenitalMakerShader = shader;
                }
            }  
            return _customBulkDecalShader;
        }
        #endregion
        // Update is called with each rendered frame by Unity
        void Update()
        {
            try
            {
                if (_dazCharacter != null)
                {
                    if (_dazCharacter != _dazCharacterSelector.selectedCharacter)
                    {
                        StartCoroutine(CharacterChanged());
                    }
                }

            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        //A public event for listeners to subscribe to
        public event EventHandler OnDestroyEvent;
        public void OnDestroy()
        {

            //Fire the event - notifying all subscribers
            if (OnDestroyEvent != null)
                OnDestroyEvent(this, null);

        }

        //public override void PreRestore()
        //{
        //    SuperController.LogError("************************************************PRE restore");
        //}

        //public override void PostRestore()
        //{
        //    SuperController.LogError("--------------------------------------------POST restore");
        //}

        public void Setup()
        {
            try
            {
                //create Header Panel
                _headerPanel = new HeaderPanel(this);

                _resetButton.button.onClick.AddListener(() =>
                {
                    ResetOriginalGPUTextures(_dazCharacter);
                });


                //UIDynamicButton NewPanelButton = CreateButton(" LAST LEFT ELEMENT");
                //NewPanelButton.button.onClick.AddListener(() => 
                //{

                //});

                //UIDynamicButton UnusedButton2 = CreateButton("LAST RIGHT ELEMENT", true);
                //UnusedButton2.button.onClick.AddListener(() =>
                //{
                //Shader[] renderers = Resources.FindObjectsOfTypeAll<Shader>();

                //});

                //this is hacky but sets the UI to look nice on start.
                _prefabButton.button.onClick.Invoke();
                _headerPanel.SelectionPanelSpec.TorsoPanel.Button.onClick.Invoke();
                _headerPanel.SelectionPanelGloss.TorsoPanel.Button.onClick.Invoke();
                _headerPanel.SelectionPanelNorm.TorsoPanel.Button.onClick.Invoke();


                _headerPanel.decalButton.button.onClick.Invoke();
                _headerPanel.SelectionPanelDecal.TorsoPanel.Button.onClick.Invoke();

                //_genitalMakerPanel.Start(GetGPUTexture("_MainTex", "torso"));
                _SetupFinished = true;
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        private IEnumerator CharacterChanged()
        {
            LogError("CharacterChanged");
            //used to know which character is being used or changed
            _dazCharacterSelector = _parentAtom.GetComponentInChildren<DAZCharacterSelector>();
            DAZCharacter previousDazCharacter = _dazCharacter;
            ResetOriginalGPUTextures(previousDazCharacter);
            _dazCharacter = _dazCharacterSelector.selectedCharacter;

            yield return new WaitUntil(() => _dazCharacter.ready);

            _dazSkin = (DAZMergedSkinV2)_dazCharacter.skin;
            _isMale = _dazCharacter.isMale;
            _uvSetName = _dazCharacter.UVname.Replace("UV: ", "");

            if (_customBulkDecalShader == null)
            {
                //load custom asset bundle and get the customshader or use the one that exists
                StartCoroutine(CreateAssetAtom("Chokpahi-Asset", "Chokpahi-Asset"));
                yield return new WaitUntil(() => DefineShaders() != null);
            }

            if (_SetupFinished == false)
            {
                yield return new WaitUntil(() => _customBulkDecalShader == true);
                Setup();
                LogError("setup should be finished" + _SetupFinished);
            }

            yield return new WaitUntil(() => _SetupFinished);
            LogError("UI should be ready");

            _headerPanel.UpdateSelectionPanels();

            if (_savedData != null)
            {
                LogError("Restore save state");
                PerformLoad(_savedData);
                _savedData = null;
            }
            else
            {
                StartCoroutine(ApplyDecalsThreaded(0));
            }
        }
        //This was needed for Normal Maps which need conversion before display in UI
        private IEnumerator ThreadedImageApply(ImagePanel imagePanel, string MaterialSlot, string TextureSlot)
        {
            yield return new WaitForSeconds(0);

            Texture2D orig = GetGPUTexture("_BumpMap", TextureSlot);

            Material material = TempManager.TempMaterial(_customNormShader);
            material.SetTexture("_BumpMap0", orig);
            Texture2D temp = GpuCombine(_clearTex, material, true);
           
            Texture2D final = new Texture2D(4096, 4096, TextureFormat.RGBA32, false, true);
            Graphics.CopyTexture(temp, final);
               
            imagePanel.ApplyTexture(final);

            yield break;
        }
        public void UpdateSelectionPanels(SelectionPanel selectionPanel)
        {
            LogError("UpdateSelectionPanels " + selectionPanel.PanelName);
            Texture2D temp = null;
            foreach (var panel in selectionPanel.Selections)
            {
                string MaterialSlot = panel.Value.MaterialSlot;
                string TextureSlot = panel.Key;

                if (MaterialSlot == "_DecalTex")
                {
                    temp = GetGPUTexture("_MainTex", TextureSlot);
                }
                else if (MaterialSlot == "_BumpMap")
                {   //convert any packed normals to rgb format
                    StartCoroutine(ThreadedImageApply(panel.Value.imagePanel, MaterialSlot, TextureSlot));  
                }
                else
                {
                    temp = GetGPUTexture(MaterialSlot, TextureSlot);
                }

                panel.Value.imagePanel.ApplyTexture(temp);             
            }

        }
        //called on character change or UI
        private void ResetOriginalGPUTextures(DAZCharacter dAZCharacter)
        {
            try
            {
                if (dAZCharacter == null)
                    return;

                DAZCharacterTextureControl dAZCharacterTextureControl = dAZCharacter.GetComponentInChildren<DAZCharacterTextureControl>();

                foreach (string UrlParamName in dAZCharacterTextureControl.GetUrlParamNames())
                {
                    JSONStorableUrl jsnURL = dAZCharacterTextureControl.GetUrlJSONParam(UrlParamName);

                    if (jsnURL != null)
                    {
                        Match m = Regex.Match(UrlParamName, "^([a-z].*)([A-Z].*)[A-Z].*$");

                        string regionString = m.Groups[1].Value.Capitalize();
                        string textureTypeString = m.Groups[2].Value;

                        DAZCharacterTextureControl.Region region = (DAZCharacterTextureControl.Region)Enum.Parse(typeof(DAZCharacterTextureControl.Region), regionString);
                        DAZCharacterTextureControl.TextureType textureType = (DAZCharacterTextureControl.TextureType)Enum.Parse(typeof(DAZCharacterTextureControl.TextureType), textureTypeString);

                        dAZCharacterTextureControl.StartSyncImage(null, region, textureType, false);
                    }
                }
            }
            catch (Exception e)
            {
                SuperController.LogError("Decal Maker: Error resetting custom textures " + e);
            }
            //NEED TO REAPPLY CUSTOM TEXTURES
            ResetCustomTextures(_dazCharacter);
            TempManager.DestoryAll();
        }
        //Non decal slots will get reset to BASE skin. So reapply custom skin settings
        private void ResetCustomTextures(DAZCharacter dAZCharacter)
        {
            try
            {
                if (dAZCharacter == null)
                    return;

                DAZCharacterTextureControl dAZCharacterTextureControl = dAZCharacter.GetComponentInChildren<DAZCharacterTextureControl>();
                foreach (string UrlParamName in dAZCharacterTextureControl.GetUrlParamNames())
                {
                    JSONStorableUrl jsnURL = dAZCharacterTextureControl.GetUrlJSONParam(UrlParamName);

                    if (jsnURL != null && jsnURL.val != "")
                    {
                        jsnURL.setJSONCallbackFunction(jsnURL);

                    }
                }
            }
            catch (Exception e)
            {
                SuperController.LogError("Decal Maker: Error resetting custom JSONStorableURL" + e);
            }
        }

        private void ResetAll()
        {
            ResetOriginalGPUTextures(_dazCharacter);

            foreach (var v in _headerPanel.selectionPanels)
            {
                foreach (var selPanel in v.Value.Selections)
                {
                    int count = selPanel.Value.DecalPanels.Count;
                    for (int i = 0; i < count; i++)
                    {
                        selPanel.Value.RemoveDecalPanel();
                    }
                }
            }
        }

        public void RemoveTempDecalPanels()
        {
            _headerPanel.RemoveTempDecalPanels();
        }

        public void ResetTempDecalPanelTable()
        {
            _headerPanel.ResetTempDecalPanelTable();
        }

        //used when restoring from json or profile.
        //make sure all images are loaded before applying
        private IEnumerator ApplyDecalsThreaded(float delay = 0.5f)
        {
            yield return new WaitForSeconds(delay);

            foreach (var panels in _headerPanel.selectionPanels)
            {
                foreach (var selPanel in panels.Value.Selections)
                {
                    if (selPanel.Value.DecalPanels.Count > 0)
                    {
                        foreach (DecalPanel d in selPanel.Value.DecalPanels)
                        {
                            yield return new WaitWhile(() => d.ImagePanel.ImageLoading == true);
                        }
                    }
                }
            }
            TempManager.DestoryAll();
            _headerPanel.Bake();
        }
        #region Image Baking
        private Texture2D GetGPUTexture(string MaterialSlot, string TextureSlot)
        {
            int num = _TextureIndex[TextureSlot].FirstOrDefault();
            return (Texture2D)_dazSkin.GPUmaterials[num].GetTexture(MaterialSlot);
        }
        private void SetGPUTexture(Texture2D tempTex, string MaterialSlot, string TextureSlot)
        {
            //apply textures
            foreach (int num in _TextureIndex[TextureSlot])
            {
                _dazSkin.GPUmaterials[num].SetTexture(MaterialSlot, tempTex);
            }
        }

        public void Bake(List<DecalPanel> DecalPanels, string TextureSlot, string MaterialSlot)
        {
            if (!_customBulkDecalShader || !_customNormShader || !_customSpecGlossShader)
            {
                SuperController.LogError("DECALMAKER:CUSTOM SHADER NOT FOUND.");
                return;
            }
            _queuedBakes++;
            StartCoroutine(BakeThreaded(DecalPanels, TextureSlot, MaterialSlot));
        }
        private IEnumerator BakeThreaded(List<DecalPanel> DecalPanels, string TextureSlot, string MaterialSlot)
        {
            yield return new WaitForEndOfFrame();
            switch (MaterialSlot)
            {
                case "_DecalTex":
                    StartCoroutine(BulkBakeDecal(DecalPanels, TextureSlot, MaterialSlot));
                    break;
                case "_SpecTex":
                case "_GlossTex":
                    StartCoroutine(BakeSpecular(DecalPanels, TextureSlot, MaterialSlot));
                    //StartCoroutine(BulkBakeSpecular(DecalPanels, TextureSlot, MaterialSlot));
                    break;
                case "_BumpMap":
                    StartCoroutine(BulkBakeNormal(DecalPanels, TextureSlot, MaterialSlot));
                    break;
            }

            yield return new WaitWhile(() => _queuedBakes > 0);
            TempManager.DestoryTempObjs();
        }
      
        private IEnumerator BulkBakeDecal(List<DecalPanel> DecalPanels, string TextureSlot, string MaterialSlot)
        {
            //var watch = System.Diagnostics.Stopwatch.StartNew();
            //watch.Start();
            string cacheSig = TempManager.GenerateCacheSig(DecalPanels);
            Texture2D tempTex = TempManager.GetTexture(cacheSig);

            if (tempTex == null)
            {
                List<Material> materials = new List<Material>();
                Material material = TempManager.TempMaterial(_customBulkDecalShader);
                material.mainTexture = TempManager.CopyTexture(_clearTex);

                int count = 0;
                bool linear = false;
                foreach (DecalPanel d in DecalPanels)
                {
                    material.SetVector("_DecalColor" + count, d.ImagePanel.image.color);
                    material.SetTexture("_DecalTex" + count, d.ImagePanel.image.mainTexture);
                    linear = d.ImagePanel.linear;
                    count++;
                    //we can bake 10 textures per material
                    if (count > 9)
                    {
                        count = 0;
                        materials.Add(material);
                        material = TempManager.TempMaterial(_customBulkDecalShader);
                    }
                }
                materials.Add(material);

                //Uses shader to clip part of one texture and applys it to another based on the alpha of a third texture.
                //Used to Apply "Clean" nipples and genital areas after decals have been applied.
                //This Alpha control will be Character UV specific. So Victoria has a diffrent nipple area than Olympia etc..
                if (TextureSlot == "torso" && _toggleNippleCutout.val)
                {
                    yield return new WaitForEndOfFrame();
                    Texture2D alphaTex;
                    alphaTex = TempManager.GetTexture(_uvSetName + ".png");

                    if (!alphaTex)
                    {
                        byte[] png = FileManagerSecure.ReadAllBytes(GetPackagePath(this) + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Cutout/" + _uvSetName + ".png");
                        alphaTex = TempManager.TempTexture2D(1, 1, TextureFormat.RGBA32, false);
                        alphaTex.LoadImage(png);
                        TempManager.SaveToCache(alphaTex, _uvSetName + ".png");
                    }
                    material.SetTexture("_Alpha", alphaTex);
                }
                if (TextureSlot == "genitals" && _toggleGenitalCutout.val && _isMale == false)
                {
                    yield return new WaitForEndOfFrame();
                    Texture2D alphaTex;
                    alphaTex = TempManager.GetTexture("_FemaleGenitals.png");

                    if (!alphaTex)
                    {
                        byte[] png = FileManagerSecure.ReadAllBytes(GetPackagePath(this) + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Cutout/_FemaleGenitals.png");
                        alphaTex = TempManager.TempTexture2D(1, 1, TextureFormat.RGBA32, false);
                        alphaTex.LoadImage(png);
                        TempManager.SaveToCache(alphaTex, "_FemaleGenitals.png");
                    }
                    material.SetTexture("_Alpha", alphaTex);
                }

                foreach (Material m in materials)
                {
                    tempTex = GpuCombine(tempTex ?? _clearTex, m, linear);
                    yield return new WaitForEndOfFrame();
                }

                TempManager.SaveToCache(tempTex, cacheSig);
            }

            //apply textures
            SetGPUTexture(tempTex, MaterialSlot, TextureSlot);
          
            DebugSave(tempTex, TextureSlot + "-Bulk-" + MaterialSlot + ".png");
            TempManager.MakeSessionObj(tempTex);
            _queuedBakes--;

            //watch.Stop();
            //var elapsedMs = watch.ElapsedMilliseconds;
            //SuperController.LogError("Texture Bulkbake " + elapsedMs + " Milliseconds");
            
            yield break;
        }
        #region TODO BULK BAKING
        private IEnumerator BulkBakeSpecular(List<DecalPanel> DecalPanels, string TextureSlot, string MaterialSlot)
        {
           // var watch = System.Diagnostics.Stopwatch.StartNew();
            string cacheSig = TempManager.GenerateCacheSig(DecalPanels);
            Texture2D tempTex = TempManager.GetTexture(cacheSig);

            if (tempTex == null)
            {
                List<Material> materials = new List<Material>();
                Material material = TempManager.TempMaterial(_customSpecGlossShader);
                int count = 0;
                //if we have a specular material on Base model use it as spec0
                Texture2D mainTex = GetGPUTexture(MaterialSlot, TextureSlot);
                if (mainTex != null)
                {
                    material.SetVector("_SpecColor" + count, new Vector4(1, 1, 1, 0.5f));
                    material.SetTexture("_SpecTex" + count, mainTex);
                    count = 1;
                }

                foreach (DecalPanel d in DecalPanels)
                {
                    //SuperController.LogError("BULK " + material.HasProperty("_DecalTex" + count));
                    material.SetVector("_SpecColor" + count, new Vector4(1, 1, 1, 0.5f));
                    material.SetTexture("_SpecTex" + count, d.ImagePanel.image.mainTexture);
           
                    count++;
                    //we can bake 10 textures per material
                    if (count > 9)
                    {
                        count = 0;
                        materials.Add(material);
                        material = TempManager.TempMaterial(_customBulkDecalShader);
                    }
                }
                materials.Add(material);

               
                foreach (Material m in materials)
                {
                    //SuperController.LogError(materials.Count + " BAKING " + m.GetTexture("_DecalTex0").name);
                    tempTex = GpuCombine(tempTex ?? _clearTex, m, true);
                    yield return new WaitForEndOfFrame();
                }

                TempManager.SaveToCache(tempTex, cacheSig);
            }

            //watch.Stop();
            //var elapsedMs = watch.ElapsedMilliseconds;
            //SuperController.LogError("Texture bake was time is " + elapsedMs);

            //apply textures
            SetGPUTexture(tempTex, MaterialSlot, TextureSlot);

            DebugSave(tempTex, TextureSlot + "-" + MaterialSlot + ".png");
            TempManager.MakeSessionObj(tempTex);
            _queuedBakes--;

            yield break;

        }
        
        private IEnumerator BulkBakeNormal(List<DecalPanel> DecalPanels, string TextureSlot, string MaterialSlot)
        {
            string cacheSig = TempManager.GenerateCacheSig(DecalPanels);
            Texture2D tempTex = TempManager.GetTexture(cacheSig);

            if (tempTex == null)
            {
                List<Material> materials = new List<Material>();
                Material material = TempManager.TempMaterial(_customNormShader);
                int count = 0;
                //if we have a  material on Base model use it as tex 0
                //mainTex = GetGPUTexture(MaterialSlot, TextureSlot);
                Texture2D mainTex = (Texture2D)_headerPanel.SelectionPanelNorm.Selections[TextureSlot].image.mainTexture;
                if (mainTex != null)
                {
                    material.SetTexture("_BumpMap" + count, mainTex);
                    count = 1;
                }

                foreach (DecalPanel d in DecalPanels)
                {
                    material.SetFloat("_BumpMapScale" + count, d.ImagePanel.NormalMapScale);
                    material.SetTexture("_BumpMap" + count, d.ImagePanel.image.mainTexture);

                    count++;
                    //we can bake 10 textures per material
                    if (count > 9)
                    {
                        count = 0;
                        materials.Add(material);
                        material = TempManager.TempMaterial(_customBulkDecalShader);
                    }
                }
                materials.Add(material);

                foreach (Material m in materials)
                {
                    //SuperController.LogError(materials.Count + " BAKING " + m.GetTexture("_DecalTex0").name);
                    tempTex = GpuCombine(tempTex ?? _clearTex, m, true);
                    yield return new WaitForEndOfFrame();
                }

                TempManager.SaveToCache(tempTex, cacheSig, true);
            }

            //apply textures
            SetGPUTexture(tempTex, MaterialSlot, TextureSlot);

            DebugSave(tempTex, TextureSlot + "-" + MaterialSlot + ".png");
            TempManager.MakeSessionObj(tempTex);
            _queuedBakes--;


            yield break;
        }
        #endregion
       
        //handles Specular and Gloss linear textures
        private IEnumerator BakeSpecular(List<DecalPanel> DecalPanels, string TextureSlot, string MaterialSlot)
        {
            Texture2D tempTex = GetGPUTexture(MaterialSlot, TextureSlot);
            //Texture2D tempTex = null;
            int count = 0;
            foreach (DecalPanel d in DecalPanels)
            {
                yield return new WaitForEndOfFrame();
                if (d.ImagePanel.image.mainTexture != null)
                {

                    if (tempTex == null)
                    {
                        tempTex = TempManager.CopyTexture((Texture2D)d.ImagePanel.image.mainTexture, true);
                    }
                    else
                    {
                        yield return new WaitForEndOfFrame();
                        tempTex = GpuCombine(tempTex, _customSpecGlossShader, MaterialSlot, d.Color, d.ImagePanel.image.mainTexture, true);
                    }
                    DebugSave(tempTex, TextureSlot + "-" + MaterialSlot + " " + count + ".png");
                    count++;
                }
            }
            //apply textures
            SetGPUTexture(tempTex, MaterialSlot, TextureSlot);

            TempManager.MakeSessionObj(tempTex);
            _queuedBakes--;
            yield break;
        }

       
        #endregion
        #region Save/Load
        public void PresetLoadCallBack(string path)
        {
            PresetLoad(path);
        }

        public void PresetLoad(string path, bool temp = false, string package = null)
        {
            if (string.IsNullOrEmpty(path))
                return;

            JSONClass jc = this.LoadJSON(path) as JSONClass;
            PerformLoad(jc, temp, package, path);
        }

        public void SavePresetCallback(string path)
        {
            if (string.IsNullOrEmpty(path))
                return;

            JSONClass json = GetJSON();
            path = path.Replace(".dsgn.DecalMakerPreset", "");
            path = path + "." + DSGN + ".DecalMakerPreset.json";
            this.SaveJSON(json, path);
            SuperController.singleton.DoSaveScreenshot(path);
            SuperController.singleton.fileBrowserUI.ClearCacheImage(path);
        }

        //SAVE
        private string DSGN = "dsgn";
        public override JSONClass GetJSON(bool includePhysical = true, bool includeAppearance = true, bool forceStore = false)
        {
            JSONClass jc = base.GetJSON(includePhysical, includeAppearance, true);
            jc["SaveVersion"] = "1";

            //save
            jc["Decal"] = _headerPanel.SelectionPanelDecal.Save();
            jc["Specular"] = _headerPanel.SelectionPanelSpec.Save();
            jc["Gloss"] = _headerPanel.SelectionPanelGloss.Save();
            jc["Normal"] = _headerPanel.SelectionPanelNorm.Save();


            jc["Nipple Cutouts ON"] = _toggleNippleCutout.val.ToString();
            jc["Genital Cutouts ON"] = _toggleGenitalCutout.val.ToString();

            return jc;
        }

        //LOAD 
        public override void RestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, JSONArray presetAtoms = null, bool setMissingToDefault = true)
        {
            base.RestoreFromJSON(jc, restorePhysical, restoreAppearance, presetAtoms);
            //store and call once we have everything loaded. RestorefromJSON is too early
            _savedData = jc;
        }
        //used for JSONStorableAction
        public void PerformLoad()
        {
            PerformLoad(_savedData);
        }

        private void PerformLoad(JSONClass jc, bool temp = false, string package = null, string selectedFile = null)
        {
            if (jc == null)
                return;

            //convert to new file version if save is old
            try
            {
                if (jc["SaveVersion"] == null)
                    jc = ConvertSaveToV1(jc);

                //if (jc["SaveVersion"].AsInt == 1)
                //    jc = ConvertSaveToV2(jc);
            }
            catch
            {
                SuperController.LogError("Decal Maker: Unable to convert save");
                return;
            }
            // Load Save Data
            try
            {
                _toggleNippleCutout.RestoreFromJSON(jc); 
                _toggleGenitalCutout.RestoreFromJSON(jc);
                
                foreach (var panel in _headerPanel.selectionPanels)
                {
                    if (jc[panel.Key] != null)
                    {
                        foreach (var selPanel in panel.Value.Selections)
                        {
                            foreach (JSONClass saveJSON in jc[panel.Key][selPanel.Key] as JSONArray)
                            {
                                DecalPanel d = panel.Value.AddDecalPanel(selPanel.Key, temp);
                                if (saveJSON["Alpha"] != null)
                                {
                                    d.sliderDynamic.slider.value = (float.Parse(saveJSON["Alpha"]));
                                }
                                if (saveJSON["H"] != null)
                                {
                                    float h = float.Parse(saveJSON["H"]);
                                    float s = float.Parse(saveJSON["S"]);
                                    float v = float.Parse(saveJSON["V"]);
                                    d.jcolor.SetVal(h, s, v);
                                }
                                if (saveJSON["Path"] != null)
                                {
                                    d.RestoreImageFromJSON(saveJSON["Path"], package, selectedFile);
                                }
                            }
                        }
                    }
                }

                StartCoroutine(ApplyDecalsThreaded(0));
            }
            catch (Exception e)
            {
                SuperController.LogError("Decal Maker: Unable to Load save");
                SuperController.LogError(e.Message);
                SuperController.LogError(e.StackTrace);
                return;
            }
        }
        //upgrades old saves to new format
        private JSONClass ConvertSaveToV1(JSONClass jc)
        {
            List<string> keys = new List<string>() { "torso", "genitals", "face", "limbs" };
            JSONClass dc = new JSONClass();
            foreach (string key in keys)
            {
                if (jc[key] != null)
                {
                    dc.Add(key, jc[key]);
                }
                jc.Remove(key);
            }
            jc["Decal"] = dc;

            return jc;
        }
        private JSONClass ConvertSaveToV2(JSONClass jc)
        {
          
            //List<string> keys = new List<string>() { "torso", "genitals", "face", "limbs" };

            //List<string> panels = _headerPanel.selectionPanels.Keys.ToList();
            //foreach (string panel in panels)
            //{
            //    SuperController.LogError("Convert colors start" + panel);
            //    foreach (string key in keys)
            //    {
            //        foreach (JSONClass c in jc[panel][key] as JSONArray)
            //        {
            //            SuperController.LogError(c["H"] + " Convert colors **** " + c.ToString());
             
            //            c["DecalPanelColorPicker"]["h"] = c["H"];
            //            c["DecalPanelColorPicker"]["s"] = c["S"];
            //            c["DecalPanelColorPicker"]["v"] = c["V"];

            //            c.Remove("H");
            //            c.Remove("S");
            //            c.Remove("V");
            //        }
            //    }
            //}

            return jc;
        }
        #endregion
        #region GPU Merging
        //VAM uses System Drawing see ImageLoaderThreaded Process()
        public Texture2D GetTextureFromSurfaceShader(Material mat, int width, int height)
        {
            //Create render texture:
            RenderTexture temp = new RenderTexture(width, height, 0, RenderTextureFormat.ARGB32, RenderTextureReadWrite.sRGB);
            temp.DiscardContents();
            //Create a Quad:
            GameObject quad = GameObject.CreatePrimitive(PrimitiveType.Quad);
            MeshRenderer rend = quad.GetComponent<MeshRenderer>();

            rend.material = mat;

            // Vector3 quadScale = quad.transform.localScale / (float)((Screen.height / 2.0) / Camera.main.orthographicSize);
            Vector3 quadScale = quad.transform.localScale;
            quad.transform.position = Vector3.forward;

            //Setup camera:
            GameObject camGO = new GameObject("CaptureCam");
            Camera cam = camGO.AddComponent<Camera>();
            cam.renderingPath = RenderingPath.Forward;
            cam.orthographic = true;
            cam.clearFlags = CameraClearFlags.SolidColor;
            cam.backgroundColor = new Color(1, 1, 1, 0);
            if (cam.rect.width < 1 || cam.rect.height < 1)
            {
                cam.rect = new Rect(cam.rect.x, cam.rect.y, 1, 1);
            }
            cam.orthographicSize = 0.5f;
            cam.rect = new Rect(0, 0, quadScale.x, quadScale.y);
            cam.aspect = quadScale.x / quadScale.y;
            cam.targetTexture = temp;
            cam.allowHDR = false;


            //Capture image and write to the render texture:
            cam.Render();
            temp = cam.targetTexture;

            //Apply changes:
            Texture2D newTex = new Texture2D(temp.width, temp.height, TextureFormat.RGBA32, true, false);
            RenderTexture.active = temp;
            newTex.ReadPixels(new Rect(0, 0, temp.width, temp.height), 0, 0);
            newTex.Apply();

            //Clean up:
            RenderTexture.active = null;
            temp.Release();
            Destroy(quad);
            Destroy(camGO);

            return newTex;
        }

        public Texture2D GpuCombine(Texture2D baseTex,  Material material, bool linear = false)
        {

            int w = baseTex.width;
            int h = baseTex.height;

            RenderTextureReadWrite renderTexConversion = RenderTextureReadWrite.sRGB;
            if (linear)
            {
                renderTexConversion = RenderTextureReadWrite.Linear;
            }

            RenderTexture tmp = RenderTexture.GetTemporary(w, h, 0, RenderTextureFormat.ARGB32, renderTexConversion);        //tmp.antiAliasing = 8;
                                                                                                                             //Backup the currently set RenderTexture
            RenderTexture previous = RenderTexture.active;


            Graphics.Blit(baseTex, tmp, material);
            RenderTexture.active = tmp;

            Texture2D newTexture = TempManager.TempTexture2D(w, h, TextureFormat.RGBA32, false, linear);
            newTexture.ReadPixels(new Rect(0, 0, w, h), 0, 0, false);
            newTexture.Apply();

            // Reset the active RenderTexture
            RenderTexture.active = previous;
            RenderTexture.ReleaseTemporary(tmp);

            return newTexture;
        }
        public Texture2D GpuCombine(Texture mainTex, Shader shader, string materialSlot, Color color, Texture overlayTex = null, bool linear = false)
        {
            if (mainTex == null)
            {
                return null;
            }

            int h = mainTex.width;
            int w = mainTex.height;

            RenderTextureReadWrite renderTexConversion = RenderTextureReadWrite.sRGB;
            if (linear)
            {
                renderTexConversion = RenderTextureReadWrite.Linear;
            }

            RenderTexture tmp = RenderTexture.GetTemporary(w, h, 0, RenderTextureFormat.ARGB32, renderTexConversion);
            //tmp.antiAliasing = 8;
            //Backup the currently set RenderTexture
            RenderTexture previous = RenderTexture.active;

            Material material = TempManager.TempMaterial(shader);
            material.mainTexture = mainTex;

            if (materialSlot == "_DecalTex")
            {
                material.SetVector("_DecalColor", color);
            }
            if (overlayTex)
            {
                material.SetTexture(materialSlot, overlayTex);
            }

            Graphics.Blit(mainTex, tmp, material);
            RenderTexture.active = tmp;

            Texture2D newTexture = TempManager.TempTexture2D(w, h, TextureFormat.RGBA32, false, linear);
            newTexture.ReadPixels(new Rect(0, 0, w, h), 0, 0, false);
            newTexture.Apply();

            // Reset the active RenderTexture
            RenderTexture.active = previous;
            RenderTexture.ReleaseTemporary(tmp);

            return newTexture;
        }
      
        //From https://support.unity3d.com/hc/en-us/articles/206486626-How-can-I-get-pixels-from-unreadable-textures-
        public Texture2D GetUnreadableTexture(Texture2D texture, bool linear = false)
        {
            RenderTextureReadWrite renderTexConversion = RenderTextureReadWrite.sRGB;
            if (linear)
            {
                renderTexConversion = RenderTextureReadWrite.Linear;
            }
            //LogError("Get Unreadable texture");
            RenderTexture tmp = RenderTexture.GetTemporary(texture.width, texture.height, 0, RenderTextureFormat.ARGB32, renderTexConversion);

            // Blit the pixels on texture to the RenderTexture
            Graphics.Blit(texture, tmp);
            // Backup the currently set RenderTexture
            RenderTexture previous = RenderTexture.active;
            // Set the current RenderTexture to the temporary one we created
            RenderTexture.active = tmp;

            Texture2D newTexture = TempManager.TempTexture2D(texture.width, texture.height, TextureFormat.RGBA32, false, linear);

            newTexture.ReadPixels(new Rect(0, 0, tmp.width, tmp.height), 0, 0);
            newTexture.Apply();

            // Reset the active RenderTexture
            RenderTexture.active = previous;
            // Release the temporary RenderTexture
            RenderTexture.ReleaseTemporary(tmp);
            //LogError("Finish Getting Unreadable texture");
            return newTexture;
        }
        #endregion
    }


    #region UI Classes
    //root class that provide the basic setup and anchor for a window
    public class BasePanel
    {
        public UIDynamic spacerLeft { get; private set; }
        public UIDynamic spacerRight { get; private set; }
        private Decal_Maker _DM;
        public BasePanel(Decal_Maker DM, int size = 550)
        {
            _DM = DM;
            //create a UI Spacers to Hold our Panels
            spacerLeft = DM.CreateSpacer(false);
            spacerLeft.height = size;
            spacerRight = DM.CreateSpacer(true);
            spacerRight.height = size;
        }
    }

    public class GenitalMaker
    {
        public GameObject gameObject = new GameObject("GenitalPanel");
        private BasePanel _basePanel;
        public  Image image { get; private set; }
        private UIDynamic spacerLeft { get { return _basePanel.spacerLeft; } }
        private UIDynamic spacerRight { get { return _basePanel.spacerRight; } }
        private Decal_Maker _DM;
        public GenitalMaker(Decal_Maker DM)
        {
            _DM = DM;
            _basePanel = new BasePanel(DM);

            image = gameObject.AddComponent<Image>();
            image.material = new Material(Shader.Find("UI/Default-Overlay"));


            image.color = Color.white;
            RectTransform imageRect = image.rectTransform;
            imageRect.sizeDelta = new Vector2(500, 500);
            image.gameObject.transform.SetParent(spacerLeft.transform, false);


            GridLayoutGroup glg = spacerRight.gameObject.AddComponent<GridLayoutGroup>();
            glg.cellSize = new Vector2(500, 120);

            glg.constraint = GridLayoutGroup.Constraint.FixedColumnCount;
            glg.constraintCount = 1;
            glg.padding = new RectOffset(10, 10, 10, 10);
            glg.spacing = new Vector2(10, 0);




            //sliders
            UIDynamicSlider Hue = CreateSlider(TEST, 0, 1, 1, "HUE");
            UIDynamicSlider Sat = CreateSlider(TEST, -1, 1, 0, "SAT");
            UIDynamicSlider Val = CreateSlider(TEST, 0, 1, 1, "VAL");

            Hue.gameObject.transform.SetParent(spacerRight.transform, false);
            Sat.gameObject.transform.SetParent(spacerRight.transform, false);
            Val.gameObject.transform.SetParent(spacerRight.transform, false);
        }
        private void TEST(float value)
        { 
        
        }

        public void Start(Texture2D torso)
        {
            Material material = new Material(_DM._customUIGenitalMakerShader);

            byte[] Genital_Base = FileManagerSecure.ReadAllBytes(_DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Cutout/Genital_Base.png");
            Texture2D Genital_BaseTex = TempManager.TempTexture2D(1, 1, TextureFormat.RGBA32, false);
            Genital_BaseTex.LoadImage(Genital_Base);

            byte[] Genital_Base_Anus = FileManagerSecure.ReadAllBytes(_DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Cutout/Genital_Base_Anus.png");
            Texture2D Genital_Base_AnusTex = TempManager.TempTexture2D(1, 1, TextureFormat.RGBA32, false);
            Genital_Base_AnusTex.LoadImage(Genital_Base_Anus);

            byte[] Genital_Base_Hood = FileManagerSecure.ReadAllBytes(_DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Cutout/Genital_Base_Hood.png");
            Texture2D Genital_Base_HoodTex = TempManager.TempTexture2D(1, 1, TextureFormat.RGBA32, false);
            Genital_Base_HoodTex.LoadImage(Genital_Base_Hood);

            byte[] Genital_Base_Labia = FileManagerSecure.ReadAllBytes(_DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Cutout/Genital_Base_Labia.png");
            Texture2D Genital_Base_LabiaTex = TempManager.TempTexture2D(1, 1, TextureFormat.RGBA32, false);
            Genital_Base_LabiaTex.LoadImage(Genital_Base_Labia);

            
            
            material.SetColor("_GenitalColor", new Color(1, 0, 1, 0));
            material.SetColor("_HoodColor", new Color(1, 1, 1, 0));
            material.SetColor("_LabiaColor", new Color(1, 1, 0,0));
            material.SetColor("_AnusColor", new Color(1,1,1,0));

            material.SetTexture("_GenitalTex", Genital_BaseTex);
            material.SetTexture("_HoodTex", Genital_Base_HoodTex);
            material.SetTexture("_LabiaTex", Genital_Base_LabiaTex);
            material.SetTexture("_AnusTex", Genital_Base_AnusTex);

            material.SetTexture("_TorsoTex", torso);


            //_DM.DebugSave(torso,"TorsoTEX.png");
            //_DM.DebugSave(Genital_BaseTex, "TGenital_BaseTex.png");
            //_DM.DebugSave(Genital_Base_AnusTex, "Genital_Base_AnusTex.png");
            //_DM.DebugSave(Genital_Base_HoodTex, "enital_Base_HoodTex.png");
            //_DM.DebugSave(Genital_Base_LabiaTex, "Genital_Base_LabiaTex.png");

            GameObject.Destroy(image.material);
            image.material = material;

        }

        private UIDynamicSlider CreateSlider(UnityAction<float> action, int min = 0, int max = 1, int value = 1, string title = "")
        {
            Transform sliderPrefab = GameObject.Instantiate<Transform>(_DM.manager.configurableSliderPrefab);
            sliderPrefab.SetParent(gameObject.transform, false);
            sliderPrefab.localPosition = Vector3.zero;

            UIDynamicSlider sliderDynamic = sliderPrefab.GetComponent<UIDynamicSlider>();
            sliderDynamic.transform.localPosition = new Vector2(0, -80);
            sliderDynamic.quickButtonsEnabled = false;
            sliderDynamic.rangeAdjustEnabled = false;
            sliderDynamic.defaultButtonEnabled = false;


            Image sliderBackground = sliderDynamic.GetComponentsInChildren<Image>().Where(x => x.name == "Panel").First();
            Color c = sliderBackground.color;
            c.a = 0.1f;
            sliderBackground.color = c;

            sliderDynamic.slider.onValueChanged.AddListener(action);
            sliderDynamic.slider.minValue = min;
            sliderDynamic.slider.maxValue = max;
            sliderDynamic.slider.value = value;
            sliderDynamic.label = title;
            //sliderDynamic.labelText.transform.localPosition += new Vector3(400, 0, 0);

            return sliderDynamic;
        }
    }
    public class PrefabPanel
    {
        public GameObject gameObject = new GameObject("PresetPanel");
        public ImagePanel ImagePanel { get; private set; }

        private Dictionary<string, List<PrefabCollection>> prefabFiles = new Dictionary<string, List<PrefabCollection>>();
        
        private Decal_Maker _DM;
        private BasePanel _basePanel;
        private UIDynamic spacerLeft { get { return _basePanel.spacerLeft; }  }
        private UIDynamic spacerRight { get { return _basePanel.spacerRight; } }
        

        private string selectedType;
        private string selectedItem;

        List<string> author = new List<string>();
        List<string> prefabTypes = new List<string>();
        List<string> prefabNames = new List<string>();

        JSONStorableStringChooser jsc;
        JSONStorableStringChooser jsc2;
        public PrefabPanel(Decal_Maker DM)
        {
            _DM = DM;
            _basePanel = new BasePanel(DM);

            ImagePanel = new ImagePanel();
            ImagePanel.gameObject.transform.SetParent(spacerRight.transform, false);
            RectTransform imageRect = ImagePanel.image.GetComponent<RectTransform>();
            imageRect.sizeDelta = new Vector2(500, 500);

            GridLayoutGroup glg = spacerLeft.gameObject.AddComponent<GridLayoutGroup>();
            glg.cellSize = new Vector2(500, 100);

            glg.constraint = GridLayoutGroup.Constraint.FixedColumnCount;
            glg.constraintCount = 1;
            glg.padding = new RectOffset(10, 10, 10, 10);
            glg.spacing = new Vector2(10, 0);


            Transform popupPrefabType = GameObject.Instantiate<Transform>(_DM.manager.configurableScrollablePopupPrefab);
            popupPrefabType.SetParent(spacerLeft.gameObject.transform, false);
            popupPrefabType.localPosition = Vector3.zero;

            UIDynamicPopup dynamicPopupType = popupPrefabType.GetComponent<UIDynamicPopup>();
            dynamicPopupType.name = "CLASS";
            //popupToJSONStorableStringChooser.Add(PrefabType, jsc);
            jsc = new JSONStorableStringChooser("name", prefabTypes, "", "Choose Type");
            jsc.popup = dynamicPopupType.popup;


            Transform popupPrefabItem = GameObject.Instantiate<Transform>(_DM.manager.configurableScrollablePopupPrefab);
            popupPrefabItem.SetParent(spacerLeft.gameObject.transform, false);
            popupPrefabItem.localPosition = Vector3.zero;

            UIDynamicPopup dynamicPopupItem = popupPrefabItem.GetComponent<UIDynamicPopup>();
            dynamicPopupItem.name = "ITEM";
            dynamicPopupItem.popup.showSlider = false;

            RefreshPrefabCollection();
            jsc2 = new JSONStorableStringChooser("name", prefabNames, "", "Choose Prefab");
            jsc2.popup = dynamicPopupItem.popup;

            dynamicPopupType.popup.onValueChangeUnityEvent.AddListener(TypeValueChanges);
            dynamicPopupItem.popup.onValueChangeUnityEvent.AddListener(ItemValueChanged);

            ImagePanel.Button.onClick.AddListener(() =>
            {
                _DM.ResetTempDecalPanelTable();
            });

            GameObject imageObject = new GameObject("text background");
            imageObject.transform.SetParent(ImagePanel.gameObject.transform, false);
            Image ima = imageObject.AddComponent<Image>();
            ima.color = new Color(.8f, .8f, .8f);
            RectTransform imRT = imageObject.GetComponent<RectTransform>();
            imageObject.transform.localPosition += new Vector3(0, -5f, 0);
            imRT.anchorMin = Vector2.zero;
            imRT.anchorMax = new Vector2(1, 0.1f);
            imRT.sizeDelta = Vector2.zero;


            //Button Text
            GameObject textObject = new GameObject("button text");
            textObject.transform.SetParent(imageObject.gameObject.transform, false);
            //used to prevent text object from blocking clicks
            CanvasGroup cg = textObject.AddComponent<CanvasGroup>();
            cg.blocksRaycasts = false;

            Text panelText = textObject.AddComponent<Text>();
            panelText.alignment = TextAnchor.MiddleCenter;
            panelText.color = Color.black;
            panelText.font = Resources.GetBuiltinResource<Font>("Arial.ttf");
            panelText.fontSize = 30;
            panelText.fontStyle = FontStyle.Bold;
            panelText.text = "Make current Prefab Permanent";

            RectTransform ptRT = panelText.GetComponent<RectTransform>();
            ptRT.anchorMin = new Vector2(0, .02f);
            ptRT.anchorMax = Vector2.one;
            ptRT.sizeDelta = Vector2.zero;

        }

        private void TypeValueChanges(string value)
        {
            selectedType = value;
            RefreshPrefabCollection();
            List<PrefabCollection> a = prefabFiles[value];
            prefabNames = a.Select(x => x.ItemName).ToList();
            prefabNames.Insert(0, "");
            jsc2.SetVal("");
            ResetItem();
            jsc2.choices = prefabNames;
        }

        private void ItemValueChanged(string value)
        {
            selectedItem = value;
            _DM.RemoveTempDecalPanels();
            if (value == "")
            {
                ResetItem();
            }
            else
            {
                PrefabCollection c = prefabFiles[selectedType].Where(x => x.ItemName == value).FirstOrDefault();
                //reset decals added from other prefabs
                if (c.ImagePath != null)
                    ImagePanel.LoadPNG(c.ImagePath, ImagePanel);

                _DM.PresetLoad(c.Path, true, c.Package);
            }
        }

        private void ResetItem()
        {
            _DM.RemoveTempDecalPanels();
            ImagePanel.ClearTexture();
            _DM.PresetLoad(_DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Icons/EMPTY.dsgn.DecalMakerPreset.json", true);
        }

        public void RefreshPrefabCollection()
        {
            string path = FileManagerSecure.NormalizePath("Custom/Scripts/Chokaphi/VAM_Decal_Maker/Presets/PreFabs");
            if (!FileManagerSecure.DirectoryExists(path))
                return;

            prefabFiles = new Dictionary<string, List<PrefabCollection>>();


            List<string> files = _DM.GetFilesAtPathRecursive(path, null);

            List<ShortCut> shortCuts = FileManagerSecure.GetShortCutsForDirectory(path);

            foreach (ShortCut s in shortCuts)
            {
                if (s.isLatest && s.package != "" && s.package != "AddonPackages Flattened" && s.package != "AddonPackages Filtered")
                {
                    List<string> temp = _DM.GetFilesAtPathRecursive(s.path, null);
                    foreach (string SCFile in temp)
                    {
                        PrefabCollection pc = new PrefabCollection(SCFile, s.package);
                        if (pc.ItemType != null)
                        {
                            if (prefabFiles.ContainsKey(pc.ItemType))
                            {
                                prefabFiles[pc.ItemType].Add(pc);
                            }
                            else
                            {
                                prefabFiles.Add(pc.ItemType, new List<PrefabCollection>() { pc });
                            }
                        }
                    }
                }
            }


            foreach (string file in files)
            {
                PrefabCollection pc = new PrefabCollection(file);
                if (pc.ItemType != null)
                {
                    if (prefabFiles.ContainsKey(pc.ItemType))
                    {
                        prefabFiles[pc.ItemType].Add(pc);
                    }
                    else
                    {
                        prefabFiles.Add(pc.ItemType, new List<PrefabCollection>() { pc });
                    }
                }
            }
            prefabTypes = prefabFiles.Keys.ToList();
            jsc.choices = prefabTypes;
        }

        public void OnClick()
        {
            bool state = !spacerLeft.gameObject.activeSelf;
            spacerLeft.gameObject.SetActive(state);
            spacerRight.gameObject.SetActive(state);
            RefreshPrefabCollection();
        }
    }

    public class DecalPanel
    {
        public GameObject gameObject = new GameObject("DecalPanel");
        public ImagePanel ImagePanel { get; private set; }

        public MyButton Up { get; private set; }
        public MyButton Down { get; private set; }
        public MyButton Open { get; private set; }
        public MyButton Close { get; private set; }

        public Color Color { get { return ImagePanel.image.color; } }

        public JSONStorableColor jcolor { get; private set; }

        public UIDynamicSlider sliderDynamic { get; private set; }

        public Action<string> LastDir;

        public Text panelText { get; private set; }

        Decal_Maker _DM;

        private UIDynamicSlider CreateSlider(UnityAction<float> action, int min = 0, int max = 1, int value = 1, string title = "")
        {
            Transform sliderPrefab = GameObject.Instantiate<Transform>(_DM.manager.configurableSliderPrefab);
            sliderPrefab.SetParent(gameObject.transform, false);
            sliderPrefab.localPosition = Vector3.zero;

            sliderDynamic = sliderPrefab.GetComponent<UIDynamicSlider>();
            sliderDynamic.transform.localPosition = new Vector2(0, -80);
            sliderDynamic.quickButtonsEnabled = false;
            sliderDynamic.rangeAdjustEnabled = false;
            sliderDynamic.defaultButtonEnabled = false;
           

            Image sliderBackground = sliderDynamic.GetComponentsInChildren<Image>().Where(x => x.name == "Panel").First();
            Color c = sliderBackground.color;
            c.a = 0.1f;
            sliderBackground.color = c;

            sliderDynamic.slider.onValueChanged.AddListener(action);
            sliderDynamic.slider.minValue = min;
            sliderDynamic.slider.maxValue = max;
            sliderDynamic.slider.value = value;
            sliderDynamic.label = title;
            sliderDynamic.labelText.transform.localPosition += new Vector3(400, 0,0);

            return sliderDynamic;
        }
        public DecalPanel(Transform anchor, float width, float height, Color? color, Decal_Maker DM, bool isNormalMap = false, bool linear = false)
        {
            gameObject.transform.SetParent(anchor, false);

            _DM = DM;
            //basePanel
            Image panelImage = gameObject.AddComponent<Image>();
            panelImage.material = new Material(Shader.Find("UI/Default-Overlay"));
            panelImage.color = color ?? new Color(0, 0, 0, 0f);
            panelImage.rectTransform.sizeDelta = new Vector2(width, height);

            //Image panel
            GameObject imageObject = new GameObject("ImagePanel");
            imageObject.transform.SetParent(gameObject.transform, false);

            ImagePanel = new ImagePanel(DM, null, null, null, isNormalMap, linear);
            ImagePanel.gameObject.transform.SetParent(gameObject.transform, false);
            ImagePanel.gameObject.transform.localPosition = new Vector3(panelImage.rectTransform.rect.xMax - ImagePanel.image.rectTransform.rect.xMax - 10, 0, 0);

            if (isNormalMap)
            {
                CreateSlider(ImagePanel.SetNormalScale, -10, 10, 1, "Normal Strength");
            }
            else if (linear)
            {
                CreateSlider(ImagePanel.SetAlpha, 1, 1, 1, "Spec/Gloss Strength").gameObject.SetActive(false);

            }
            else
            {
                CreateSlider(ImagePanel.SetAlpha, 0, 1, 1, "Alpha value");
            }



            GameObject colorObject = new GameObject("ColorPanel");
            colorObject.transform.SetParent(gameObject.transform, false);
            colorObject.transform.localScale = new Vector3(.55f, .55f, .55f);
            colorObject.transform.localPosition = new Vector2(-350, 50);


            Image colorImage = colorObject.AddComponent<Image>();
            colorImage.material = new Material(Shader.Find("UI/Default-Overlay"));
            colorImage.color = new Color(0, 1, 1, 0f);
            colorImage.rectTransform.sizeDelta = new Vector2(600, 300);
            colorImage.transform.localPosition = new Vector2(-350, 50);

            Transform colorPickerPrefab = GameObject.Instantiate<Transform>(DM.manager.configurableColorPickerPrefab);
            colorPickerPrefab.SetParent(colorImage.transform, false);
            colorPickerPrefab.localPosition = Vector3.zero;

            UIDynamicColorPicker colorPickerDynamic = colorPickerPrefab.GetComponent<UIDynamicColorPicker>();
            colorPickerDynamic.showLabel = false;
            HSVColor hsvc = HSVColorPicker.RGBToHSV(1f, 1f, 1f);
            jcolor = new JSONStorableColor("DecalPanelColorPicker", hsvc, ImagePanel.SetColor);
            jcolor.colorPicker = colorPickerDynamic.colorPicker;


            Up = new MyButton("", new Color(0.9f, 0.6f, 0.1f));
            Up.gameObject.transform.SetParent(gameObject.transform, false);
            Up.gameObject.transform.localPosition = new Vector2(-100, 50);

            RectTransform upRT = Up.gameObject.GetComponent<RectTransform>();
            upRT.sizeDelta = new Vector2(60, 60);

            byte[] tmppng = FileManagerSecure.ReadAllBytes(_DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Icons/Up-Icon.jpg");
            Texture2D UpIcon = new Texture2D(1, 1, TextureFormat.RGBA32, false);
            UpIcon.LoadImage(tmppng);
            Up.SetIcon(UpIcon);

            Down = new MyButton("", new Color(0.1f, 0.6f, 0.8f));
            Down.gameObject.transform.SetParent(gameObject.transform, false);
            Down.gameObject.transform.localPosition = Up.gameObject.transform.localPosition + new Vector3(65, 0, 0);

            RectTransform dwnRT = Down.gameObject.GetComponent<RectTransform>();
            dwnRT.sizeDelta = new Vector2(60, 60);

            tmppng = FileManagerSecure.ReadAllBytes(_DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Icons/Down-Icon.jpg");
            Texture2D DownIcon = new Texture2D(1, 1, TextureFormat.RGBA32, false);
            DownIcon.LoadImage(tmppng);
            Down.SetIcon(DownIcon);

            Close = new MyButton("");
            Close.gameObject.transform.SetParent(gameObject.transform, false);
            Close.gameObject.transform.localPosition = Down.gameObject.transform.localPosition + new Vector3(160, 0, 0);

            RectTransform clsRT = Close.gameObject.GetComponent<RectTransform>();
            clsRT.sizeDelta = new Vector2(60, 60);

            tmppng = FileManagerSecure.ReadAllBytes(_DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Icons/Close-Icon.jpg");
            Texture2D CloseIcon = new Texture2D(1, 1, TextureFormat.RGBA32, false);
            CloseIcon.LoadImage(tmppng);
            Close.SetIcon(CloseIcon);

            Open = new MyButton("", new Color(.7f, .7f, .7f));
            Open.gameObject.transform.SetParent(gameObject.transform, false);
            Open.gameObject.transform.localPosition = Up.gameObject.transform.localPosition + new Vector3(-65, 0, 0);

            RectTransform opnRT = Open.gameObject.GetComponent<RectTransform>();
            opnRT.sizeDelta = new Vector2(60, 60);

            tmppng = FileManagerSecure.ReadAllBytes(_DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Icons/Open-Icon.jpg");
            Texture2D OpenIcon = new Texture2D(1, 1, TextureFormat.RGBA32, false);
            OpenIcon.LoadImage(tmppng);
            Open.SetIcon(OpenIcon);


            //Texture Path Text
            GameObject textObject = new GameObject("textPanel");
            textObject.transform.SetParent(gameObject.transform, false);
            //used to prevent text object from blocking clicks
            CanvasGroup cg = textObject.AddComponent<CanvasGroup>();
            cg.blocksRaycasts = false;

            panelText = textObject.AddComponent<Text>();
            panelText.alignment = TextAnchor.LowerLeft;
            panelText.color = Color.black;
            panelText.font = Resources.GetBuiltinResource<Font>("Arial.ttf");
            panelText.fontSize = 30;
            panelText.fontStyle = FontStyle.Bold;
            RectTransform ptRT = panelText.GetComponent<RectTransform>();
            ptRT.sizeDelta = new Vector2(width, height);
        }

        public void SetPathText(string text)
        {
            int maxLength = 45;
            if (text.Length > maxLength)
            {
                text = text.Substring(text.Length - maxLength);
            }
            panelText.text = text;
        }

        //Used to correct paths in JSON to available VAR files until VAM expands FileManagerSecure
        //this is a nasty fucking mess
        //path = image path package
        public void RestoreImageFromJSON(string path, string package = null, string selectedFile = null)
        {
            try
            {
                path = FileManagerSecure.NormalizePath(path);
                Match m;
                //VAR Path for textures with direct var ref
                if ((m = Regex.Match(path, "^(.+\\..+)\\.(.+):/(.+/)(.+)")).Success)
                {
                    //this is a packagedVAR reference use latest version
                    string varName = m.Groups[1].Value;
                    string filePath = m.Groups[3].Value;
                    string fileName = m.Groups[4].Value;

                    ShortCut sc = FileManagerSecure.GetShortCutsForDirectory(filePath).Where(x => x.package.Contains(varName) && x.isLatest).FirstOrDefault();
                    //if nothing found with this path
                    if (sc == null)
                    {
                        SuperController.LogError("Decal Maker: Texture not found: " + path);
                        return;
                    }


                    path = Regex.Replace(sc.path, "^.+/(.+\\..+\\..+)\\..+(:.+)", "$1$2/" + fileName); //removes AddonPackages/ path prefix and the .var from shortcut path

                }
                //if texture and presets are in same VAR  VAM changes all paths to SELF:
                //prefabs UI passes in a package ref
                else if ((m = Regex.Match(path, "^SELF:.+")).Success && package != null)
                {   //SELF:/Custom/Atom/Person/Textures/DecalMaker - mofmes power goo/Face/Cheeks/face04/D.png
                    path = Regex.Replace(path, "^(SELF)(:.+)", package + "$2"); //replace SELF:/ with source package
                }
                else if ((m = Regex.Match(path, "^SELF:.+")).Success && selectedFile != null)
                {
                    if ((m = Regex.Match(selectedFile, "^(.+\\..+\\..+):.+")).Success)
                    {
                        string varName = m.Groups[1].Value;
                        path = Regex.Replace(path, "^(SELF)(:.+)", varName + "$2"); //replace SELF:/ with source package
                    }
                }
                //no fing clue. We have to find it
                else if ((m = Regex.Match(path, "^SELF:.+")).Success)
                {
                    //Find the first package with this path
                    path = Regex.Replace(path, "^SELF:/(.+/)", "$1");
                    string pathWithoutFileName = Regex.Replace(path, "^(.+/).+", "$1");

                    List<ShortCut> shortCuts = FileManagerSecure.GetShortCutsForDirectory(pathWithoutFileName);
                    foreach (ShortCut s in shortCuts)
                    {
                        if (s.isLatest && s.package != "" && s.package != "AddonPackages Flattened" && s.package != "AddonPackages Filtered")
                        {
                            List<string> files = _DM.GetFilesAtPathRecursive(s.path, null);
                            foreach (string f in files)
                            {
                                string t = FileManagerSecure.NormalizePath(f);
                                if (t.Contains(path))
                                {
                                    path = t;
                                    break;
                                }
                            }
                        }
                    }
                }

                BrowserCallBack(path);
            }
            catch (Exception e)
            {
                SuperController.LogError("Decal Maker: Unable to Resove Texture Path");
                SuperController.LogError(e.InnerException.StackTrace);
            }
        }

        public void BrowserCallBack(string path)
        {
            if (string.IsNullOrEmpty(path))
            {
                //LastDir = null;
            }
            else
            {
                SetPathText(path);
                LastDir(FileManagerSecure.GetDirectoryName(path));
                ImagePanel.LoadPNG(path, ImagePanel);
            }
        }

        public JSONClass Save()
        {
            JSONClass decalSaveJSON = new JSONClass();
            decalSaveJSON["H"].AsFloat = jcolor.val.H;
            decalSaveJSON["S"].AsFloat = jcolor.val.S;
            decalSaveJSON["V"].AsFloat = jcolor.val.V;
            decalSaveJSON["Alpha"].AsFloat = ImagePanel.image.color.a;

            //jcolor.StoreJSON(decalSaveJSON, true, true, true);
        
            if (!string.IsNullOrEmpty(ImagePanel.Path))
            {
                string relativePath = FileManagerSecure.NormalizePath(ImagePanel.Path);
                decalSaveJSON["Path"] = relativePath;
            }
            return decalSaveJSON;
        }

        public void CreateButtonScripts(SelectionPanel selectionPanel, ManagerPanel imagePanel)
        {
            Up.button.onClick.AddListener(() =>
            {
                int currentIndex = gameObject.transform.GetSiblingIndex();
                int newIndex = currentIndex - 1;
                if (newIndex >= 0)
                {
                    imagePanel.RepositionDecalPanel(this, newIndex);
                }
            });

            Down.button.onClick.AddListener(() =>
            {
                int currentIndex = gameObject.transform.GetSiblingIndex();
                int newIndex = currentIndex + 1;
                if (newIndex < imagePanel.DecalPanels.Count)
                {
                    imagePanel.RepositionDecalPanel(this, newIndex);
                }
            });

            Close.button.onClick.AddListener(() =>
            {
                imagePanel.RemoveDecalPanel(this);
            });

            Open.button.onClick.AddListener(() =>
            {
                DecalPanel d = selectionPanel.AddDecalPanel();
                int currentIndex = gameObject.transform.GetSiblingIndex();
                int newIndex = currentIndex + 1;

                imagePanel.RepositionDecalPanel(d, newIndex);
            });
        }
    }

    public class HeaderPanel
    {
        public GameObject gameObject = new GameObject("Header");

        public SelectionPanel ActivePanel { get; set; }

        public SelectionPanel SelectionPanelDecal { get; private set; }
        public SelectionPanel SelectionPanelSpec { get; private set; }
        public SelectionPanel SelectionPanelGloss { get; private set; }
        public SelectionPanel SelectionPanelNorm { get; private set; }
        public MyButton decalButton { get; private set; }
        public MyButton specButton { get; private set; }
        public MyButton glossButton { get; private set; }
        public MyButton normButton { get; private set; }

        private List<MyButton> buttons { get; set; }

        public Dictionary<string, SelectionPanel> selectionPanels { get; private set; }

        private Decal_Maker _DM;
        private BasePanel _basePanel;
        private UIDynamic spacerLeft { get { return _basePanel.spacerLeft; } }
        private UIDynamic spacerRight { get { return _basePanel.spacerRight; } }
        public HeaderPanel(Decal_Maker DM)
        {
            _DM = DM;
            _basePanel = new BasePanel(DM, 50);

            //Image i = spacerLeft.gameObject.AddComponent<Image>();
            //i.material = new Material(Shader.Find("UI/Default-Overlay"));
            //i.material.color = Color.green;

            gameObject.transform.SetParent(spacerLeft.transform, false);
            //center panel in UI
            gameObject.transform.localPosition += new Vector3(270, 10, 0);
            //basePanel
            Image panelImage = gameObject.AddComponent<Image>();
            panelImage.material = new Material(Shader.Find("UI/Default-Overlay"));
            panelImage.color = new Color(.5f, .5f, .5f, 1);
            panelImage.rectTransform.sizeDelta = new Vector2(1050, 70);

            GridLayoutGroup glg = gameObject.AddComponent<GridLayoutGroup>();
            glg.cellSize = new Vector2(200, 50);

            glg.constraint = GridLayoutGroup.Constraint.FixedRowCount;
            glg.constraintCount = 1;
            glg.padding = new RectOffset(10, 10, 10, 10);
            glg.spacing = new Vector2(10, 0);


            decalButton = new MyButton("Decal", new Color(1, 0.3f, 0.4f));
            decalButton.gameObject.transform.SetParent(gameObject.transform, false);

            specButton = new MyButton("Specular", new Color(0.95f, 0.25f, 0.91f));
            specButton.gameObject.transform.SetParent(gameObject.transform, false);

            glossButton = new MyButton("Gloss", new Color(0.2f, .98f, 0.2f));
            glossButton.gameObject.transform.SetParent(gameObject.transform, false);

            normButton = new MyButton("Normal", new Color(0.2f, 0.9f, .9f));
            normButton.gameObject.transform.SetParent(gameObject.transform, false);

            buttons = new List<MyButton>() { decalButton, specButton, glossButton, normButton };

            SelectionPanelDecal = new SelectionPanel(1050, 300, new Color(1, 1, 1, 1f), DM)
            {
                MaterialSlot = "_DecalTex",
                isNormalMap = false,
                linear = false
            };


            SelectionPanelSpec = new SelectionPanel(1050, 300, new Color(1, 1, 1, 1f), DM)
            {
                MaterialSlot = "_SpecTex",
                isNormalMap = false,
                linear = true
            };

            SelectionPanelGloss = new SelectionPanel(1050, 300, new Color(1, 1, 1, 1f), DM)
            {
                MaterialSlot = "_GlossTex",
                isNormalMap = false,
                linear = true
            };

            SelectionPanelNorm = new SelectionPanel(1050, 300, new Color(1, 1, 1, 1f), DM)
            {
                MaterialSlot = "_BumpMap",
                isNormalMap = true,
                linear = true

            };
            //now finalize panels
            SelectionPanelDecal.CreatePanels();
            SelectionPanelSpec.CreatePanels();
            SelectionPanelGloss.CreatePanels();
            SelectionPanelNorm.CreatePanels();


            SelectionPanelDecal.PanelName = "Decal";
            SelectionPanelSpec.PanelName = "Specular";
            SelectionPanelGloss.PanelName = "Gloss";
            SelectionPanelNorm.PanelName = "Normal";

            SelectionPanelDecal.ActivateWindow(true);
            SelectionPanelSpec.ActivateWindow(false);
            SelectionPanelGloss.ActivateWindow(false);
            SelectionPanelNorm.ActivateWindow(false);

            ActivePanel = SelectionPanelDecal;

            selectionPanels = new Dictionary<string, SelectionPanel> { { "Decal", SelectionPanelDecal }, { "Specular", SelectionPanelSpec }, { "Gloss", SelectionPanelGloss }, { "Normal", SelectionPanelNorm } };
            foreach (MyButton uB in buttons)
            {
                uB.button.onClick.AddListener(() =>
                {
                    foreach (MyButton b in buttons)
                    {
                        if (b.buttonText == uB.buttonText)
                        {
                            b.Selected(true);
                            ActivePanel = selectionPanels[b.buttonText.text];
                            ActivePanel.ActivateWindow(true);
                        }
                        else
                        {
                            b.Selected(false);
                            ActivePanel = selectionPanels[b.buttonText.text];
                            ActivePanel.ActivateWindow(false);
                        }
                    }
                });
            }
        }

        public void UpdateSelectionPanels()
        {
            selectionPanels["Decal"].UpdateSelectionPanels();
            selectionPanels["Specular"].UpdateSelectionPanels();
            selectionPanels["Gloss"].UpdateSelectionPanels();
            selectionPanels["Normal"].UpdateSelectionPanels();
        }

        public void Bake()
        {
            SelectionPanelDecal.Bake();
            SelectionPanelSpec.Bake();
            SelectionPanelGloss.Bake();
            SelectionPanelNorm.Bake();
        }

        public void RemoveTempDecalPanels()
        {
            SelectionPanelDecal.RemoveTempDecalPanels();
            SelectionPanelSpec.RemoveTempDecalPanels();
            SelectionPanelGloss.RemoveTempDecalPanels();
            SelectionPanelNorm.RemoveTempDecalPanels();
        }

        public void ResetTempDecalPanelTable()
        {
            SelectionPanelDecal.ResetTempDecalPanelTable();
            SelectionPanelSpec.ResetTempDecalPanelTable();
            SelectionPanelGloss.ResetTempDecalPanelTable();
            SelectionPanelNorm.ResetTempDecalPanelTable();
        }

    }

    public class MyButton
    {
        public GameObject gameObject = new GameObject("MyButton");
        public Image image { get; set; }

        public Button button { get; set; }
        public Text buttonText { get; set; }

        private DefaultControls.Resources resources = new DefaultControls.Resources();

        private Color normalColor;
        private Color unselectedColor;

        public void Selected(bool value)
        {
            if (value)
            {
                ColorBlock colors = button.colors;
                colors.normalColor = normalColor;
                button.colors = colors;
            }
            else
            {
                ColorBlock colors = button.colors;
                colors.normalColor = unselectedColor;
                button.colors = colors;
            }
        }

        public MyButton(string label = "Button", Color? color = null)
        {

            //transform = gameObject.transform;
            RectTransform rt = gameObject.AddComponent<RectTransform>();
            rt.sizeDelta = new Vector2(160, 30);

            GameObject textGO = new GameObject("Text");
            textGO.transform.SetParent(gameObject.transform, false);

            RectTransform tRT = textGO.AddComponent<RectTransform>();
            tRT.anchorMin = Vector2.zero;
            tRT.anchorMax = Vector2.one;
            tRT.sizeDelta = Vector2.zero;

            buttonText = textGO.AddComponent<Text>();
            buttonText.text = label;
            buttonText.alignment = TextAnchor.MiddleCenter;
            buttonText.color = Color.black;

            buttonText.font = Resources.GetBuiltinResource<Font>("Arial.ttf");
            buttonText.fontSize = 30;

            image = gameObject.AddComponent<Image>();
            image.material = new Material(Shader.Find("UI/Default-Overlay"));
            //image.color = color ?? Color.green;

            normalColor = color ?? new Color(0.6f, 0, 0, 1);
            button = gameObject.AddComponent<Button>();

            //convert color to HSV to allow easier lighten/darken operation
            float H, S, V;
            Color.RGBToHSV(normalColor, out H, out S, out V);
            ColorBlock colors = button.colors;
            colors.highlightedColor = Color.HSVToRGB(H, S, V * 1.4f);
            colors.normalColor = normalColor;
            colors.pressedColor = normalColor;// Color.HSVToRGB(H, S, V * 1.2f);
            unselectedColor = Color.HSVToRGB(H, S, V * 0.5f);

            button.colors = colors;
        }

        public void SetIcon(Texture2D icon)
        {
            image.material.mainTexture = icon;
        }
    }

    public class SelectionPanel
    {
        public GameObject gameObject = new GameObject("Panel");

        public string PanelName { get; set; }
        public UIDynamicButton AddButton { get; private set; }
        public UIDynamicButton RemoveButton { get; private set; }

        public Dictionary<string, ManagerPanel> Selections { get; private set; }
        public ManagerPanel ActivePanel { get; private set; }
        public ManagerPanel TorsoPanel { get; private set; }
        public ManagerPanel GenitalPanel { get; private set; }
        public ManagerPanel FacelPanel { get; private set; }
        public ManagerPanel LimbsPanel { get; private set; }

        public string MaterialSlot { get; set; }
        public bool isNormalMap { get; set; } = false;
        public bool linear { get; set; } = false;


        private Decal_Maker _mVR;
        private string _lastDir;
        private BasePanel _basePanel;
        private UIDynamic spacerLeft { get { return _basePanel.spacerLeft; } }
        private UIDynamic spacerRight { get { return _basePanel.spacerRight; } }

        public SelectionPanel(float width, float height, Color? color, Decal_Maker mVR)
        {
            _basePanel = new BasePanel(mVR, 300);

            //Image i = spacerLeft.gameObject.AddComponent<Image>();
            //i.material = new Material(Shader.Find("UI/Default-Overlay"));
            //i.material.color = Color.blue;

            _mVR = mVR;

            //create buttons to add/remove panels
            AddButton = mVR.CreateButton("Add Image");
            RemoveButton = mVR.CreateButton("Remove Image", true);


            gameObject.transform.SetParent(spacerLeft.transform, false);
            gameObject.transform.localPosition += new Vector3(270, 0, 0);
            //basePanel
            Image panelImage = gameObject.AddComponent<Image>();
            panelImage.material = new Material(Shader.Find("UI/Default-Overlay"));
            panelImage.color = color ?? new Color(.9f, .9f, .9f, 1);
            panelImage.rectTransform.sizeDelta = new Vector2(width, height);

            GridLayoutGroup glg = gameObject.AddComponent<GridLayoutGroup>();
            glg.cellSize = new Vector2(250, 250);

            glg.constraint = GridLayoutGroup.Constraint.FixedRowCount;
            glg.constraintCount = 1;
            glg.padding = new RectOffset(10, 10, 10, 10);
            glg.spacing = new Vector2(10, 0);


            AddButton.button.onClick.AddListener(() => { AddDecalPanel(); });
            RemoveButton.button.onClick.AddListener(RemoveDecalPanel);

        }

        public void CreatePanels()
        {
            //Torso panel
            TorsoPanel = new ManagerPanel(_mVR, null, "torso", MaterialSlot, isNormalMap, linear);
            TorsoPanel.gameObject.transform.SetParent(gameObject.transform, false);


            //Genital panel
            GenitalPanel = new ManagerPanel(_mVR, null, "genitals", MaterialSlot, isNormalMap, linear);
            GenitalPanel.gameObject.transform.SetParent(gameObject.transform, false);
            // GenitalPanel.image.transform.localPosition = TorsoPanel.gameObject.transform.localPosition + new Vector3(270, 0, 0);

            //Face panel
            FacelPanel = new ManagerPanel(_mVR, null, "face", MaterialSlot, isNormalMap, linear);
            FacelPanel.gameObject.transform.SetParent(gameObject.transform, false);
            //FacelPanel.image.transform.localPosition = GenitalPanel.gameObject.transform.localPosition + new Vector3(270, 0, 0);

            //Limbs panel
            LimbsPanel = new ManagerPanel(_mVR, null, "limbs", MaterialSlot, isNormalMap, linear);
            LimbsPanel.gameObject.transform.SetParent(gameObject.transform, false);
            //LimbsPanel.image.transform.localPosition = FacelPanel.gameObject.transform.localPosition + new Vector3(270, 0, 0);

            ActivePanel = TorsoPanel;
            Selections = new Dictionary<string, ManagerPanel>() { { "torso", TorsoPanel }, { "genitals", GenitalPanel }, { "face", FacelPanel }, { "limbs", LimbsPanel } };
            foreach (var sel in Selections)
            {
                sel.Value.Button.onClick.AddListener(() =>
                {
                    foreach (var b in Selections)
                    {
                        if (b.Key == sel.Key)
                        {
                            b.Value.Button.image.color = Color.white;
                            b.Value.ActivateWindow(true);
                            ActivePanel = b.Value;
                        }
                        else
                        {
                            b.Value.Button.image.color = Color.grey;
                            b.Value.ActivateWindow(false);
                        }
                    }
                });
            }
            ActivateWindow(false);
        }

        public void ActivateWindow(bool value)
        {
            spacerLeft.gameObject.SetActive(value);
            spacerRight.gameObject.SetActive(value);
            AddButton.gameObject.SetActive(value);
            RemoveButton.gameObject.SetActive(value);
            ActivePanel.ActivateWindow(value);
        }

        public void UpdateSelectionPanels()
        {
            _mVR.UpdateSelectionPanels(this);
        }

        public JSONClass Save()
        {
            JSONClass jc = new JSONClass();
            foreach (var selPanel in Selections)
            {
                JSONArray Panel = new JSONArray();

                if (selPanel.Value.DecalPanels.Count > 0)
                {
                    foreach (DecalPanel d in selPanel.Value.DecalPanels)
                    {
                        JSONClass tempDecal = d.Save();
                        Panel.Add("", tempDecal);
                    }

                }
                jc[selPanel.Key] = Panel;
            }
            return jc;
        }

        public void Bake()
        {
            //LogError("baking selectionPanel " + customShader.name);
            TorsoPanel.Bake();
            GenitalPanel.Bake();
            FacelPanel.Bake();
            LimbsPanel.Bake();
        }

        public DecalPanel AddDecalPanel()
        {
            DecalPanel d = AddDecalPanels(ActivePanel);

            return d;
        }

        public DecalPanel AddDecalPanel(string panelName, bool temp = false)
        {
            ManagerPanel active = null;
            switch (panelName)
            {
                case "torso":
                    active = TorsoPanel;
                    break;
                case "genitals":
                    active = GenitalPanel;
                    break;
                case "face":
                    active = FacelPanel;
                    break;
                case "limbs":
                    active = LimbsPanel;
                    break;
            }

            DecalPanel d = AddDecalPanels(active, temp);

            return d;
        }

        private DecalPanel AddDecalPanels(ManagerPanel active, bool temp = false)
        {
            DecalPanel d = new DecalPanel(active.spacerLeft.transform, 1050, 300, UnityEngine.Random.ColorHSV(0f, 1f, 1f, 1f, 0.5f, 1f), _mVR, isNormalMap, linear);
            d.gameObject.transform.localPosition += new Vector3(270, 0, 0);
            active.IncreaseDecalPanel(d, temp);
            d.LastDir = SetLastDir;

            d.ImagePanel.Button.onClick.AddListener(() =>
            {
                if (_lastDir == null)
                {
                    _lastDir = "Custom/Atom/Person/Textures";
                }
                else if (_lastDir.Contains("var:"))
                {
                    _lastDir = "Custom/Atom/Person/Textures";
                }

                List<ShortCut> shortCuts = FileManagerSecure.GetShortCutsForDirectory("Custom/Atom/Person/Textures/", false, true, true, false);
                SuperController.singleton.GetMediaPathDialog(new FileBrowserCallback(d.BrowserCallBack), "", _lastDir, true, true, false, null, false, shortCuts);
            });

            d.CreateButtonScripts(this, active);

            return d;
        }

        public void RemoveDecalPanel()
        {
            ActivePanel.RemoveDecalPanel();
        }

        public void RemoveTempDecalPanels()
        {
            _mVR.StartCoroutine(TorsoPanel.RemoveTempDecalPanels());
            _mVR.StartCoroutine(GenitalPanel.RemoveTempDecalPanels());
            _mVR.StartCoroutine(FacelPanel.RemoveTempDecalPanels());
            _mVR.StartCoroutine(LimbsPanel.RemoveTempDecalPanels());
        }

        public void ResetTempDecalPanelTable()
        {
            TorsoPanel.ResetTempDecalPanelTable();
            GenitalPanel.ResetTempDecalPanelTable();
            FacelPanel.ResetTempDecalPanelTable();
            LimbsPanel.ResetTempDecalPanelTable();
        }

        void SetLastDir(string s)
        {
            _lastDir = s;
        }

    }

    //Controls the display of Decal Level UI elements
    //split off from ImagePanel to focus class
    public class ManagerPanel
    { 
        public ImagePanel imagePanel { get; set; }
        public GameObject gameObject { get { return imagePanel.gameObject; } }
        public Image image { get { return imagePanel.image; } set { imagePanel.image = value; } }
       
        public string imageHash { get { return imagePanel.imageHash; } }
        public bool ImageLoading { get { return imagePanel.ImageLoading; } }
        public string Path { get { return imagePanel.Path; } }
        public Button Button { get { return imagePanel.Button; } }
        public string TextureSlot { get { return imagePanel.TextureSlot; } }
        public string MaterialSlot { get { return imagePanel.MaterialSlot; } }
        //tell VAM image system how the texture should be loaded
        public bool isNormalMap { get { return imagePanel.isNormalMap; } }
        public bool linear { get { return imagePanel.linear; } }

        //controls the addition and removal of all panels
        public List<DecalPanel> DecalPanels { get; set; } = new List<DecalPanel>();
        private List<DecalPanel> TempDecalPanels { get; set; } = new List<DecalPanel>();
        public UIDynamic spacerLeft { get; private set; }
        public UIDynamic spacerRight { get; private set; }

        private Decal_Maker _DM;

        public ManagerPanel(Decal_Maker DM = null, Color? color = null, string textureSlot = null, string materialSlot = null, bool setNormalMap = false, bool setLinear = false)
        {
            _DM = DM;
            imagePanel = new ImagePanel(DM , color, textureSlot, materialSlot, setNormalMap, setLinear);

            GameObject textObject = new GameObject("Region Text");
            textObject.AddComponent<RectTransform>();
            textObject.transform.SetParent(gameObject.transform, false);
            textObject.transform.localPosition = new Vector3(0, -35, 0);

            Text text = textObject.AddComponent<Text>();
            text.text = textureSlot.ToUpper() ?? "";
            text.alignment = TextAnchor.LowerCenter;
            text.color = new Color(0.196078435f, 0.196078435f, 0.196078435f, 1f);
            text.font = Resources.GetBuiltinResource<Font>("Arial.ttf");
            text.fontStyle = FontStyle.Bold;
            text.fontSize = 30;
            RectTransform component = textObject.GetComponent<RectTransform>();
            component.anchorMin = Vector2.zero;
            component.anchorMax = Vector2.one;
            component.sizeDelta = Vector2.zero;

            spacerLeft = DM.CreateSpacer(false);
            spacerLeft.height = 300;

            spacerRight = DM.CreateSpacer(true);
            spacerRight.height = 300;

            //Image i = spacerLeft.gameObject.AddComponent<Image>();
            //i.material = new Material(Shader.Find("UI/Default-Overlay"));
            //i.material.color = Color.red;

            GridLayoutGroup glg = spacerLeft.gameObject.AddComponent<GridLayoutGroup>();
            glg.cellSize = new Vector2(1050, spacerLeft.height);

            glg.constraint = GridLayoutGroup.Constraint.FixedColumnCount;
            glg.constraintCount = 1;
            //glg.padding = new RectOffset(10, 10, 10, 10);
            glg.spacing = new Vector2(0, 0);

            RemoveDecalPanel();
            ActivateWindow(false);
            
        }

        public void IncreaseDecalPanel(DecalPanel d, bool temp = false)
        {
            DecalPanels.Add(d);

            ResizeSpacers(300);

            if (temp)
            {
                TempDecalPanels.Add(d);
            }
        }

        public void RemoveDecalPanel()
        {
            if (DecalPanels.Any())
            {
                GameObject.Destroy(DecalPanels.Last().gameObject);
                DecalPanels.RemoveAt(DecalPanels.Count - 1);
            }
            ResizeSpacers(-300);
        }

        public void RemoveDecalPanel(DecalPanel d)
        {
            bool removed = DecalPanels.Remove(d);
            if (removed)
            {
                GameObject.Destroy(d.gameObject);
                ResizeSpacers(-300);
            }
        }

        public IEnumerator RemoveTempDecalPanels()
        {
            foreach (DecalPanel d in TempDecalPanels.ToList())
            {
                yield return new WaitWhile(() => false);
                RemoveDecalPanel(d);
            }
        }

        public void ResetTempDecalPanelTable()
        {
            TempDecalPanels = new List<DecalPanel>();
        }

        public void RepositionDecalPanel(DecalPanel d, int index)
        {
            d.gameObject.transform.SetSiblingIndex(index);
            DecalPanels.Remove(d);
            DecalPanels.Insert(index, d);
        }

        public void Bake()
        {
            if (DecalPanels.Count > 0)
            {
                _DM.Bake(DecalPanels, TextureSlot, MaterialSlot);
            }
        }

        private void ResizeSpacers(float value)
        {
            spacerLeft.height += value;
            spacerRight.height += value;
        }

        public void ActivateWindow(bool value)
        {
            spacerLeft.gameObject.SetActive(value);
            spacerRight.gameObject.SetActive(value);
        }

    }

    public class ImagePanel
    {
        public GameObject gameObject = new GameObject("ImagePanel");

        public Image image { get; set; }
        public float NormalMapScale { get; private set; } = 1f;
        public string imageHash { get; private set; }
        public bool ImageLoading { get; private set; }
        public string Path { get; set; }
        public Button Button { get; private set; }
        public string TextureSlot { get; private set; }
        public string MaterialSlot { get; private set; }
        //tell VAM image system how the texture should be loaded
        public bool isNormalMap { get; private set; }
        public bool linear { get; private set; }
        Decal_Maker _DM;
        public ImagePanel(Decal_Maker DM = null, Color? color = null, string textureSlot = null, string materialSlot = null, bool setNormalMap = false, bool setLinear = false)
        {
            _DM = DM;
            TextureSlot = textureSlot;
            MaterialSlot = materialSlot;
            isNormalMap = setNormalMap;
            linear = setLinear;

            image = gameObject.AddComponent<Image>();
            image.material = new Material(Shader.Find("UI/Default-Overlay"));
            
            
            image.color = color ?? new Color(1, 1, 1, 1f);

            RectTransform imageRect = image.rectTransform;
            imageRect.sizeDelta = new Vector2(300, 300);

            Button = gameObject.AddComponent<Button>();
        }

        public void SetNormalScale(float value)
        {
            NormalMapScale = value;
            //SuperController.LogError("_NormalScale " + value + " " + image.material.GetFloat("_NormalScale"));

            Material mat = new Material(_DM._customUINormalMapShader);
            mat.SetFloat("_NormalScale", value);
            mat.mainTexture = image.mainTexture;
            
            GameObject.Destroy(image.material);
            image.material = mat;
        }

        public void SetAlpha(float value)
        {
            Color newAlpha = image.color;
            newAlpha.a = value;
            image.color = newAlpha;
        }

        public void SetColor(JSONStorableColor jcolor)
        {
            Color color = jcolor.colorPicker.currentColor;
            Color newColor = image.color;
            newColor.r = color.r;
            newColor.g = color.g;
            newColor.b = color.b;
            image.color = newColor;
        }

        public void ClearTexture()
        {
            UnityEngine.Object.Destroy(image.material);
            image.material = new Material(Shader.Find("UI/Default-Overlay"));
        }

        //Use existing texture
        public void ApplyTexture(Texture2D texture)
        {
            Material material = new Material(Shader.Find("UI/Default-Overlay"));
            material.SetTexture("_MainTex", texture);
            UnityEngine.Object.Destroy(image.material);
            image.material = material;
        }
        
        //load texture from disk
        private void OnImageLoaded(ImageLoaderThreaded.QueuedImage qi)
        {
            if (qi != null)
            {
                //create new material instance so we can change texture seperatly
                if (isNormalMap)
                {
                    image.material = new Material(_DM._customUINormalMapShader);  
                }
                else
                {
                    image.material = new Material(Shader.Find("UI/Default-Overlay"));
                }

                image.material.mainTexture = qi.tex;
                Path = qi.imgPath;
                imageHash = ComputeImagehash(qi.tex);

                ImageLoading = false;
            }
        }

        private string ComputeImagehash(Texture2D tex)
        {
            if (tex == null)
                return "ERROR";

            byte[] raw = tex.GetRawTextureData();

            using (MD5 md5 = MD5.Create())
            {
                byte[] bytes = md5.ComputeHash(raw);
                StringBuilder builder = new StringBuilder(bytes.Length * 2);
                for (int i = 0; i < bytes.Length; i++)
                {
                    builder.Append(bytes[i].ToString("x2"));
                }
                return builder.ToString();
            }
        }

        //Old VAM version does not give access to load texture so use VAM image loading routine instead
        //Newer can use FileManagementSecure.FileManagerSecure or loadTexture
        //Wil call OnImageLoad once finished   
        public void LoadPNG(string filePath, ImagePanel callBack)
        {
            ImageLoaderThreaded.QueuedImage queuedImage = new ImageLoaderThreaded.QueuedImage();
            queuedImage.imgPath = filePath;
            queuedImage.forceReload = false;
            queuedImage.createMipMaps = false;
            queuedImage.isNormalMap = isNormalMap;
            queuedImage.isThumbnail = false;
            queuedImage.linear = linear;
            queuedImage.createAlphaFromGrayscale = false;
            queuedImage.compress = false;//!queuedImage.isNormalMap;

            queuedImage.callback = new ImageLoaderThreaded.ImageLoaderCallback(callBack.OnImageLoaded); // = new ImageLoaderThreaded.ImageLoaderCallback(OnImageLoaded);

            //start image load
            ImageLoaderThreaded.singleton.QueueImage(queuedImage);
            ImageLoading = true;
        }

    }
   
    public class PrefabCollection
    {
        public string Author { get; private set; }
        public string ItemType { get; private set; }
        public string ItemName { get; private set; }
        public string Path { get; private set; }
        public string Package { get; private set; }

        public string ImagePath { get; private set; }

        public PrefabCollection(string path, string package = null)
        {
            string fileName = GetFileName(path);

            Path = path;
            Package = package;
            MatchCollection mc = Regex.Matches(fileName, "^(.*)_(.*)_(.*).dsgn.DecalMakerPreset.json");

            foreach (Match m in mc)
            {
                Author = m.Groups[1].Value;
                ItemType = m.Groups[2].Value;
                ItemName = m.Groups[3].Value;
                string imagePath = path.Replace(".json", ".jpg");
                if (FileManagerSecure.FileExists(imagePath))
                {
                    ImagePath = imagePath;
                }
            }
        }


        //from C# PATH
        char[] sep = new char[] { '/', '\\' };
        private string GetFileName(string path)
        {
            int num = path.LastIndexOfAny(sep);
            if (num >= 0)
            {
                return path.Substring(num + 1);
            }
            return path;
        }
    }
    #endregion

    public class CacheFile
    {
        public string FileName { get; set; }
        public DateTime Created { get; private set; }
        public int width { get; set; }
        public int height { get; set; }
        public TextureFormat format { get; set; }
        public bool linear { get; set; } = false;
      

        public CacheFile(Texture2D texture, bool Linear )
        {
            FileName = string.Format(@"{0}.cache", Guid.NewGuid());
            Created = DateTime.Now;
            width = texture.width;
            height = texture.height;
            format = texture.format;
            linear = Linear;
        }

        public CacheFile(JSONArray array)
        {
            FileName = array[0];
            Created = DateTime.Parse(array[1]);
            width = array[2].AsInt;
            height = array[3].AsInt;
            format = (TextureFormat)Enum.Parse(typeof(TextureFormat), array[4]);
            linear = array[5].AsBool;
        }
     
        public void UpdateTime()
        {
            Created = DateTime.Now;
        }
        public void Load()
        { 
        
        }

        public void Save()
        { 
        
        }
    }
    public static class TempManager
    {
        #region temp files
        //truely temp
        static List<UnityEngine.Object> tempObjects;
        //need to keep until character or skin change
        static List<UnityEngine.Object> sessionObjects;

        public static MVRScript mVR { get; set; }

        static TempManager()
        {
            tempObjects = new List<UnityEngine.Object>();
            sessionObjects = new List<UnityEngine.Object>();
        }
        //Create Temp Material
        public static Material TempMaterial(Shader shader)
        {
            Material temp = new Material(shader);
            tempObjects.Add(temp);

            return temp;
        }

        //Create Temp Texture
        public static Texture2D TempTexture2D(int width, int height, TextureFormat format, bool mip = false, bool linear = false)
        {
            Texture2D temp = new Texture2D(width, height, format, mip, linear);
            tempObjects.Add(temp);
            //LogError("Stored temp objects contains " + tempObjects.Count);
            return temp;
        }
        //Create Copy of existing texture
        public static Texture2D CopyTexture(Texture2D src, bool linear = false)
        {
            Texture2D cpy = TempTexture2D(src.width, src.height, src.format, false, linear);
            Graphics.CopyTexture(src, cpy);

            return cpy;
        }

        //copy temp into session
        public static void MakeSessionObj(UnityEngine.Object obj)
        {
            if (obj == null)
                return;

            tempObjects.Remove(obj);
            sessionObjects.Add(obj);
        }

        //remove temp texture
        public static void DestroyTexture(UnityEngine.Object obj)
        {
            if (obj == null)
                return;

            tempObjects.Remove(obj);
            UnityEngine.Object.Destroy(obj);
        }
        public static void DestoryTempObjs()
        {
            foreach (var obj in tempObjects)
            {
                UnityEngine.Object.Destroy(obj);
            }

            tempObjects = new List<UnityEngine.Object>();
            //LogError("Stored temp objects Destoyed");
        }

        public static void DestorySessionObjects()
        {
            foreach (var obj in sessionObjects)
            {
                UnityEngine.Object.Destroy(obj);
            }
            sessionObjects = new List<UnityEngine.Object>();
            //LogError("Stored temp objects Destoyed");
        }

        public static void DestoryAll()
        {
            foreach (var obj in tempObjects)
            {
                UnityEngine.Object.Destroy(obj);
            }
            foreach (var obj in sessionObjects)
            {
                UnityEngine.Object.Destroy(obj);
            }
            tempObjects = new List<UnityEngine.Object>();
            sessionObjects = new List<UnityEngine.Object>();
            //LogError("All temp objects Destoyed");
        }

#endregion
        #region TextureCache

        public static string GenerateCacheSig(List<DecalPanel> DecalPanels)
        {
            //calculate what current panels cache name will be

            string nips = mVR.GetBoolJSONParam("Nipple Cutouts ON").val.ToString();
            string gens = mVR.GetBoolJSONParam("Genital Cutouts ON").val.ToString();
           
            string cacheSig = string.Concat(new string[] { nips, "_", gens, "_" });

            foreach (DecalPanel d in DecalPanels)
            {
               
                string h = d.ImagePanel.imageHash;
                string r = d.Color.r.ToString();
                string g = d.Color.g.ToString();
                string b = d.Color.b.ToString();
                string a = d.sliderDynamic.slider.value.ToString();

                cacheSig += string.Concat(new string[] {h, "_", r, "_", g, "_", b, "_", a, "-" });
            }

            return cacheSig;
        }

        private static Dictionary<string, CacheFile> CacheFiles = null;
        public static void SaveCacheMeta()
        {
            try
            {
                JSONClass cacheFileJSON = new JSONClass();
                foreach (var dic in CacheFiles)
                {
                    JSONArray temp = new JSONArray();
                    temp.Add(dic.Value.FileName);
                    temp.Add(dic.Value.Created.ToString());
                    temp.Add(dic.Value.width.ToString());
                    temp.Add(dic.Value.height.ToString());
                    temp.Add(dic.Value.format.ToString());
                    temp.Add(dic.Value.linear.ToString());
                    cacheFileJSON[dic.Key] = temp;
                }
                mVR.SaveJSON(cacheFileJSON, cachePath + "CacheFiles.json");
            }
            catch(Exception e)
            {
                SuperController.LogError("Failed to save Cache json " + e.Message);
            }
        }

        private static JSONClass LoadJSON(string path)
        {
            JSONClass json = new JSONClass();
            try
            {
                if (FileManagerSecure.FileExists(path))
                {
                    json = mVR.LoadJSON(path) as JSONClass;
                }
            }
            catch (Exception e)
            {
                SuperController.LogError("DecalMaker:TempManager LoadJSON " + e.Message);
            }

            return json;
        }
        //use plugin writable directory instead of VAM Cache location
        static string cachePath = "Custom/PluginData/Chokaphi/VAM_Decal_Maker/DecalMakerCache/";
        private static void LoadCacheMeta()
        {
            try
            {             
                if (!FileManagerSecure.FileExists(cachePath))
                    FileManagerSecure.CreateDirectory(cachePath);
                

                JSONClass cacheFileJSON = LoadJSON(cachePath + "CacheFiles.json");
                CacheFiles = new Dictionary<string, CacheFile>();

                foreach (string a in cacheFileJSON.Keys)
                {
                    JSONArray jSONArray = cacheFileJSON[a].AsArray;
                    CacheFiles[a] = new CacheFile(jSONArray);
                }

                CleanCacheFolder();
            }
            catch (Exception e)
            {
                SuperController.LogError("Failed to load Cache json " + e.Message);
            }
        }
       
        
        public static Texture2D GetTexture(string cacheSig)
        {
            try
            {
                if (CacheFiles == null)
                    LoadCacheMeta();


                CacheFile file;
                if (CacheFiles.TryGetValue(cacheSig, out file))
                {
                    if (FileManagerSecure.FileExists(cachePath + file.FileName))
                    {
                        byte[] bytes = FileManagerSecure.ReadAllBytes(cachePath + file.FileName);

                        Texture2D tex = TempManager.TempTexture2D(file.width, file.height, file.format, false, file.linear);
                        tex.LoadRawTextureData(bytes);
                        tex.Apply(false);

                        file.UpdateTime();
                        return tex;
                    }
                    else
                    {   //cache miss from mising file
                        CacheFiles.Remove(cacheSig);
                    }
                }
 
                return null;
            }
            catch (Exception e)
            {
                SuperController.LogError(e.Message);
                return null;
            }
        }
        public static void SaveToCache(Texture2D texture, string cacheSig, bool linear = false)
        {
            if (CacheFiles == null)
                LoadCacheMeta();

            if (CacheFiles.ContainsKey(cacheSig))
            {
                return;
            }
            CacheFile cacheFile = new CacheFile(texture, linear);
            CacheFiles.Add(cacheSig, cacheFile);

            FileManagerSecure.WriteAllBytes(cachePath + cacheFile.FileName, texture.GetRawTextureData());
            SaveCacheMeta();
        }
        public static void CleanCacheFolder()
        {
            //remove OLD Cache entries after we get to a certain size
            if (CacheFiles.Count > 80)
            {
                int pct = (CacheFiles.Count/100) * 20;
                var oldest = CacheFiles.OrderBy(x => x.Value.Created).Take(pct);
                Dictionary<string, CacheFile> a = oldest.ToDictionary(c => c.Key, c => c.Value);
                foreach (var old in a)
                {
                    if (RemoveFile(old.Value.FileName))
                    {
                        CacheFiles.Remove(old.Key);
                    }
                }
                SaveCacheMeta();
            }
        }
        private static bool RemoveFile(string path)
        {
            try 
            {
                FileManagerSecure.DeleteFile(cachePath+path);
                return true;
            }
            catch (Exception e)
            {
                SuperController.LogError("Decal Maker Cache Remove:" + e.Message);
            }
            return false;
        }

        #endregion

    }

}

